<?php
/**
 * Sphider Version 5.4.*
 * Sphider is licensed under the GNU GPL.
 *
 * PHP version 5.4
 *
 * @category Sphider_Search
 * @package  Admin
 * @author   R. Prew  <CaptQ@blog.worldspaceflight.com>
 * @license  GNU GPL
 * @link     http://www.sphidersearch.com
 *
 * Original base code by:
 *   Ando Saabas  ando(a t)set.ee 
 */
header('Content-Type: text/html; charset=utf-8');
//error_reporting(E_ERROR | E_DEPRECATED); //Development only
error_reporting(0);

$include_dir = "../include";
require "$include_dir/commonfuncs.php";
require "auth.php";
extract(getHttpVars());
$settings_dir = "../settings";
$template_dir = "../templates";
require "$settings_dir/conf.php";
set_time_limit(0);
$map_dir = $log_dir."/../sitemaps";
$report_dir = $log_dir."/../reports";

echo "<!DOCTYPE HTML>
  <html lang='en'>
  <head>
  <meta charset='UTF-8'>
  <title>Sphider administrator tools</title>
  <link rel='stylesheet' href='admin.css' type='text/css' />
  <script type='text/javascript' src='dbmain.js'></script>
  </head>
  <body>";

if (!isset($f)) {
    $f=2;
}
$site_funcs = Array (22=> "default", 21=> "default", 4=> "default", 19=> "default",
  1=> "default", 2=> "default", "add_site" => "default", 20=> "default",
  "edit_site" => "default", 5=>"default", 28=> "default", 30=> "default",
  31=> "default", 33=> "default", 48=> "default");
$feed_funcs = Array (37=> "default", 38=> "default", 41=> "default",
  42=> "default", 43=> "default", 44=> "default", "prune_feed" => "default",
  47=> "default", "show_feeds" => "default", "edit_feed" => "default",
  "add_feed" => "default", "rssindex" => "default", 40=> "default");
$stat_funcs = Array ("statistics" => "default",  "delete_log"=> "default",
  "delete_map"=> "default", "delete_report"=> "default");
$settings_funcs = Array ("settings" => "default");
$index_funcs = Array ("index" => "default");
$clean_funcs = Array ("clean" => "default", 15=>"default", 16=>"default",
  17=>"default", 23=>"default", "clean_doms" => "default", "clean_imgs" => "default",
  "clean_feeds" => "default");
$cat_funcs = Array (11=> "default", 10=> "default", "categories" => "default",
  "edit_cat"=>"default", "delete_cat"=>"default", "add_cat" => "default",
  7=> "default");
$database_funcs = Array ("database" => "default");

echo "<div id='admin'>
  <div id='tabs'>
  <ul>";
if (array_key_exists($f, $stat_funcs) ) {
    $stat_funcs[$f] = "selected";
} else {
    $stat_funcs[$f] = "default";
}

if (array_key_exists($f, $site_funcs) ) {
    $site_funcs[$f] = "selected";
} else {
    $site_funcs[$f] = "default";
}

if (array_key_exists($f, $feed_funcs) ) {
    $feed_funcs[$f] = "selected";
} else {
    $feed_funcs[$f] = "default";
}

if (array_key_exists($f, $settings_funcs) ) {
    $settings_funcs[$f] = "selected";
} else {
    $settings_funcs[$f] = "default";
}

if (array_key_exists($f, $index_funcs) ) {
    $index_funcs[$f]  = "selected";
} else {
    $index_funcs[$f] = "default";
}

if (array_key_exists($f, $cat_funcs) ) {
    $cat_funcs[$f]  = "selected";
} else {
    $cat_funcs[$f] = "default";
}

if (array_key_exists($f, $clean_funcs) ) {
    $clean_funcs[$f]  = "selected";
} else {
    $clean_funcs[$f] = "default";
}

if (array_key_exists($f, $database_funcs) ) {
    $database_funcs[$f]  = "selected";
} else {
    $database_funcs[$f] = "default";
}
    echo "<li><a href='admin.php?f=2' class='".$site_funcs[$f]
      ."'>Sites</a> </li>
      <li><a href='admin.php?f=show_feeds' class='".$feed_funcs[$f]
      ."'>Feeds</a> </li>
      <li><a href='admin.php?f=categories' class='".$cat_funcs[$f]
      ."'>Categories</a></li>
      <li><a href='admin.php?f=index' class='".$index_funcs[$f]
      ."'>Index</a></li>
      <li><a href='admin.php?f=clean' class='".$clean_funcs[$f]
      ."'>Clean tables</a> </li>
      <li><a href='admin.php?f=settings' class='".$settings_funcs[$f]
      ."'>Settings</a></li>
      <li><a href='admin.php?f=statistics' class='".$stat_funcs[$f]
      ."'>Statistics</a> </li>
      <li><a href='admin.php?f=database' class='".$database_funcs[$f]
      ."'>Database</a></li>
      <li><a href='admin.php?f=24' class='default'>Log out</a></li>
      </ul>
      </div>"; // End 'tabs' 
    echo "<div id='main'>";


/**
 * List the categories
 *
 * @param int    $parent  ID of the category's parent
 * @param int    $lev     Top level or sub-category
 * @param string $color   Alternating color bars for readability
 * @param string $message Page informational data
 *
 * @return void
 */
function listCats($parent, $lev, $color, $message)
{
    global $mysql_table_prefix, $db, $key;

    if ($lev == 0) {
        echo "<div id='submenu'>
          <ul>
          <li><a href='admin.php?f=add_cat'>Add category</a> </li>
          </ul>
          </div>"
          .$message
          ."<br>
          <br><div class='stat_container' style='width:20%; border:none;'>";
    }
    $space = "";
    for ($x = 0; $x < $lev; $x++) {
        $space .= "&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    $query = "SELECT * FROM ".$mysql_table_prefix."categories "
      ."WHERE parent_num = ? ORDER BY category";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $parent);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        while ($row = $result->fetch_array(MYSQLI_ASSOC)) {
            if ($color =="white") {
                $color = "#f2f2f2";
            } else {
                $color = "white";
            }
            $id = $row['category_id'];
            $cat = $row['category'];
            echo "<div class='row' style='background-color:".$color.";'>
              <div class='stat_col' style='width:90%; text-align:left;'>"
              .$space."<a href='admin.php?f=edit_cat&amp;cat_id="
              .$id."'>".htmlentities($cat ?? '', ENT_QUOTES, 'UTF-8')
              ."</a></div><div class='stat_col' style='width:5%;'><a href='admin.php"
              ."?f=edit_cat&amp;cat_id=".$id."' class='small_button'>Edit</a></div>
              <div class='stat_col' style='width:5%;'> <a href='admin.php?f=11&amp;"
              ."cat_id=".$id."&amp;Submit=".$key
              ."' onclick=\"return confirm('Are you sure you want to delete?"
              ." Subcategories will be lost.')\" class='small_button'>Delete</a>
			  </div>
              </div>";
            $color = listCats($id, $lev + 1, $color, "");
        }
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    if ($lev == 0) {
        echo "</div><br>";
    }
    return $color;
}


/**
 * Walk through the categories
 *
 * @param int $parent  Category's parent
 * @param int $lev     Top level or sub-category
 * @param int $site_id ID of the site being viewed
 *
 * @return void
 */
function walkThroughCats($parent, $lev, $site_id)
{
    global $mysql_table_prefix, $db, $rtn_str;

    $space = "";
    if (!isset($rtn_str)) {
        $rtn_str = "";
    }
    for ($x = 0; $x < $lev; $x++) {
        $space .= "&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    $query = "SELECT * FROM ".$mysql_table_prefix."categories "
      ."WHERE parent_num = ? ORDER BY category";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $parent);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    while ($row = $result->fetch_array(MYSQLI_ASSOC)) {
        $id = $row['category_id'];
        $cat = $row['category'];
        $state = '';
        if ($site_id <> '') {
            $stmt2 = $db->prepare(
                "SELECT * FROM ".$mysql_table_prefix
                ."site_category WHERE site_id = ? AND category_id = ?"
            );
            if ($stmt2) {
                $stmt2->bind_param("ii", $site_id, $id);
                $stmt2->execute() or die("Execution failed: ".$stmt2->error);
                $stmt2->store_result();
                $rows = $stmt2->num_rows;
                if ($rows > 0) {
                    $state = "checked";
                }
                $stmt2->free_result();
                $stmt2->close();
            } else {
                trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
            }
        }
        $rtn_str = $rtn_str . $space . "<input type=checkbox name='cat[".$id."]' "
          .$state.">" . htmlentities($cat ?? '', ENT_QUOTES, 'UTF-8') . "<br>";
        walkThroughCats($id, $lev + 1, $site_id);
    }

    return $rtn_str;
}


/**
 * Form to add a new category
 *
 * @param int $parent Parent of the category being created
 *
 * @return void
 */
function addCatForm($parent)
{
    global $mysql_table_prefix, $db, $key;

    $par2 = "";
    $par2num = "";
    echo "<div id='submenu'>
      </div>";
    if ($parent=='') {
        $par='(Top level)'; 
    } else {
        $query = "SELECT category, parent_num FROM ".$mysql_table_prefix
          ."categories WHERE category_id = ?";
        $stmt = $db->prepare($query);
        if ($stmt) {
            $stmt->bind_param("i", $parent);
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $stmt->bind_result($category, $parent_num);
            $stmt->store_result();
            if ($stmt->fetch()) {
                $par = $category;
                $query1 = "SELECT category_id, category FROM ".$mysql_table_prefix
                  ."categories WHERE category_id = ?";
                $stmt1 = $db->prepare($query1);
                if ($stmt1) {
                    $stmt1->bind_param("i", $parent_num);
                    $stmt1->execute() or die("Execution failed: ".$stmt1->error);
                    $stmt1->bind_result($cat_id, $cat1);
                    if ($stmt1->fetch()) {
                        $par2num = $cat_id;
                        $par2 = $cat1;
                    } else {
                        $par2 = "Top level: ";
                    }
                    $stmt1->close();
                } else {
                    trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
                }
            }
            $stmt->free_result();
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
    }

    echo "<br>
      <form action=admin.php method=post>
      <input type=hidden name=f value=7>
      <input type=hidden name=parent value='"
      .htmlentities($parent ?? '', ENT_QUOTES, 'UTF-8')."'>
	  <input type=hidden name='Submit' value='".$key."'>
      <div class='stat_container' style='width:25%; border:none;'>
      <div class='row' style=''>
      <div class='stat_col' style='text-align:center; border:none;'><b>Parent:
      <a href='admin.php?f=add_cat&amp;parent=".$par2num."'>".$par2."</a>"
      .htmlentities($par ?? '', ENT_QUOTES, 'UTF-8')."</b></div></div>
      <div class='row'><div class='stat_col' style='border:none;'>
      <b>Category:</b> <input type=text name=category size=40></div></div>
      <div class='row'><br><div class='stat_col' style='border:none;
      text-align:center;'><input type=submit id='submit' value=Add></div></div>";
    $query = "SELECT category_id, category FROM ".$mysql_table_prefix
      ."categories WHERE parent_num = ?";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $parent);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->bind_result($category_id, $category);
        $stmt->store_result();
        $num_rows = $stmt->num_rows;
        if ($num_rows>0) {
            echo "<br><b>Create subcategory under</b><br><br>";
        }
        while ($stmt->fetch()) {
            echo "<a href=\"admin.php?f=add_cat&amp;parent=".$category_id."\">"
              .htmlentities($category ?? '', ENT_QUOTES, 'UTF-8')."</a><br>";
        }
        $stmt->free_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    echo "</div></form>";
}


/**
 * Add a category
 *
 * @param string $category Name of the category
 * @param int    $parent   Parent of ther created category
 *
 * @return void
 */
function addCat($category, $parent)
{
    global $mysql_table_prefix, $db, $key, $Submit;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    if ($category=="") {
        return;
    }
    $category = addslashes($category);
    if ($parent == "") {
        $parent = 0;
    }
    $query = "INSERT INTO ".$mysql_table_prefix."categories (category, "
      ."parent_num) VALUES ( ? , ? )";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("si", $category, $parent);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->close();
        return "<div style='text-align:center;'><b>Category "
          .htmlentities($category ?? '', ENT_QUOTES, 'UTF-8')." added.</b></div>" ;
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
}


/**
 * The form from which we add a site
 *
 * @return void
 */
function addSiteForm()
{
    global $key;

    echo "<div style='text-align:center;' id='submenu'><b>Add a site</b></div>
      <br><div>
      <form action=admin.php method=post>
      <input type=hidden name=f value=1>
      <input type=hidden name=af value=2>
      <input type=hidden name='Submit' value='".$key."'>
      <div class='stat_container' style='width:39%; border:none;'>
      <div class='row'><div class='stat_col' style='width:23%; border:none;
      text-align:left;'><b>URL:</b></div>
      <div class='stat_col' style='width:77%; text-align:left; border:none;'>
      <input type=text name=url size=60 value='http://'></div></div>
      <div class='row'><div class='stat_col' style='width:23%; border:none;
      text-align:left;'><b>Title:</b></div>
      <div class='col_stat' style='width:77%; text-align:left; border:none;'>
      <input type=text name=title size=60></div></div>
      <div class='row'><div class='stat_col' style='width:23%; border:none;
      text-align:left; padding-top:30px; vertical-align:top;'><b>Short description:
      </b></div>
      <div class='stat_col' style='width:77%; border:none; text-align:left;'>
      <textarea name=short_desc cols=45 rows=3 wrap='soft'></textarea></div></div>
      <div class='row'><div class='stat_col' style='width:23%; border:none;
      text-align:left;'>Category:</div><div class='stat_col' style='width:77%; 
      border:none;text-align:left;'>".walkThroughCats(0, 0, '')."</div></div>
      <div class='row'><div class='stat_col' style='width:23%; border:none;'>
      </div><div class='stat_col' style='width:77%; border:none; text-align:left;'>
      <input type=submit id='submit' value=Add></div></div></div></form></div>";
}


/**
 * The form used to edit a site
 *
 * @param int $site_id The numeric id of the site
 *
 * @return void
 */
function editSiteForm($site_id)
{
    global $mysql_table_prefix, $db, $key;
    global $row, $ctlang;

    $query = "SELECT site_id, url, title, short_desc, spider_depth, required, "
      ."disallowed, usesitemap, ignore_robots, can_leave_domain, foreign_images, "
      ."link_log, ct_lang from ".$mysql_table_prefix."sites where site_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $site_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $row = $result->fetch_array(MYSQLI_ASSOC);
    $depth = $row['spider_depth'];
    $fullchecked = "";
    $depthchecked = "";
    if ($depth == -1 ) {
        $fullchecked = "checked";
        $depth ="";
    } else {
        $depthchecked = "checked";
    }
    $usesitemap = $row['usesitemap'];
    if ($usesitemap == 1) {
        $checksitemap = "checked";
    } else {
        $checksitemap = "";
    }
    $ignore_robots = $row['ignore_robots'];
    if ($ignore_robots == 1) {
        $checkrobots = "checked";
    } else {
        $checkrobots = "";
    }
    $leave_domain = $row['can_leave_domain'];
    if ($leave_domain == 1 ) {
        $domainchecked = "checked";
    } else {
        $domainchecked = "";
    }
    $idx_foreign_imgs = $row['foreign_images'];
    if ($idx_foreign_imgs == 1) {
        $foreignchecked = "checked";
    } else {
        $foreignchecked = "";
    }
    $link_log = $row['link_log'];
    if ($link_log == 1) {
        $linklog = "checked";
    } else {
        $linklog = "";
    }
    $ct_lang = $row['ct_lang'];
    $ctlang = $ct_lang;
    echo "<div style='text-align:center;' id='submenu'><b>Edit site</b>
      </div>
      <br><div>
      <form action=admin.php method=post>
      <input type=hidden name=f value=4>
      <input type=hidden name='usesitemap' value='0'>
      <input type=hidden name='linklog' value='0'>
      <input type=hidden name='ignore_robots' value='0'>
      <input type=hidden name='domaincb' value='0'>
      <input type=hidden name='foreignimgs' value='0'>
      <input type=hidden name=site_id value=".$site_id.">
      <input type=hidden name='Submit' value='".$key."'>
      <div class='stat_container' style='width:40%; border:none;'>
      <div class='row'><div class='stat_col' style='width:28%; border:none;
      text-align:left;'><b>URL:</b></div><div class='stat_col' style='width:72%;
      border:none; text-align:left;'><input type=text name=url value='"
      .htmlentities($row['url'] ?? '', ENT_QUOTES, 'UTF-8')."' size=60></div></div>
      <div class='row'><div class='stat_col' style='width:28%; border:none;
      text-align:left;'><b>Title:</b></div><div class='stat_col' style='width:72%;
      border:none; text-align:left;'><input type=text name=title value='"
      .htmlentities($row['title'] ?? '', ENT_QUOTES, 'UTF-8')."' size=60></div></div>
      <div class='row'><div class='stat_col' style='width:28%; border:none;
      text-align:left; padding-top:30px; vertical-align:top;'><b>Short description:
      </b></div><div class='stat_col' style='width:72%; border:none;'
      text-align:left;'><textarea name=short_desc cols=45 rows=3 wrap>"
      .htmlentities($row['short_desc'] ?? '', ENT_QUOTES, 'UTF-8')."</textarea></div>
      </div>
      <div class='row'><div class='stat_col' style='width:28%; border:none;
      text-align:left; padding-top:50px; vertical-align:top;'><b>Spidering options:
      </b></div><div class='stat_col' style='width:72%; border:none;
      text-align:left;'><input type='radio' name='soption' value='full' "
      .$fullchecked."> Full<br>
      <input type='radio' name='soption' value='level' ".$depthchecked
      .">To depth: <input type='text' name='depth' size='2' value='"
      .$depth."'><br>
      <input type='checkbox' name='usesitemap' value='1' ".$checksitemap
      ."> Index using a sitemap, if available<br>
      <input type='checkbox' name='linklog' value='1' ".$linklog
      ."> Create a links report<br>
      <input type='checkbox' name='ignore_robots' value='1' ".$checkrobots
      ."> Ignore robots.txt for images (Not recommended)<br>
      <input type='checkbox' name='domaincb' value='1' ".$domainchecked
      ."> Spider can leave domain<br>
      <input type='checkbox' name='foreignimgs' value='1' ".$foreignchecked
      ."> Index foreign images<br>";
      commonTextLang();      
      echo "</div></div>
      <div class='row'><div class='stat_col' style='width:28%; border:none;
      text-align:left; padding-top:20px; vertical-align:top;'><b>URLs must include:
      </b></div><div class='stat_col' style='width:72%; border:none;
      text-align:left;'><textarea name='in' cols=45 rows=2 wrap='soft'>"
      .$row['required']."</textarea></div></div>
      <div class='row'><div class='stat_col' style='width:28%; border:none;
      text-align:left; padding-top:20px; vertical-align:top;'><b>URLs must not
      include:</b></div><div class='stat_col' style='width:72%; border:none;
      text-align:left;'><textarea name=out cols=45 rows=2 wrap='soft'>"
      .$row['disallowed']."</textarea></div></div>
      <div class='row'><div class='stat_col' style='width:28%; border:none;
      text-align:left; padding-top:15px; vertical-align:top;'>Category:</div>
      <div class='stat_col' style='width:72%; border:none; text-align:left;'>"
      .walkThroughCats(0, 0, $site_id)."</div></div>
      <div class='row'><div class='stat_col' style='width:28%; border:none;'>
      </div><div class='stat_col' style='width:72%; border:none;
      text-align:left;'><input type='submit' id='submit' value='Update'></div>
      </div></div></form></div>";
}


/**
 * Edit a site
 *
 * @param int    $site_id       ID of the edited site
 * @param string $url           URL of the edited site
 * @param string $title         Title of the site
 * @param string $short_desc    Short description of the site
 * @param int    $depth         How deep to index the site
 * @param string $required      List of MUST patterns
 * @param string $disallowed    List of must NOT patterns
 * @param int    $usesitemap    Flag to use a sitemap, if available
 * @param int    $ignore_robots Flag to ignore robots.txt while indexing images
 * @param int    $domaincb      Flag indicating if spider may leave the domain
 * @param int    $foreignimgs   Flag indicating if non-integral images are indexed
 * @param int    $cat           The category identifier
 * @param int    $linklog       Flag to create a links report
 * @param string $ctlang        Common text language
 *
 * @return void
 */
function editSite(
    $site_id, $url, $title, $short_desc, $depth, $required, $disallowed,
    $usesitemap, $ignore_robots, $domaincb, $foreignimgs, $cat, $linklog, $ctlang
) {

    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    if ($depth == "") {
        $depth = 2;
    }
    $short_desc = addslashes($short_desc);
    $title = addslashes($title);
    $dquery = "DELETE FROM ".$mysql_table_prefix."site_category "
      ."WHERE site_id = ? ";
    $dstmt = $db->prepare($dquery);
    if ($dstmt) {
        $dstmt->bind_param("i", $site_id);
        $dstmt->execute() or die("Execution failed: ".$dstmt->error);
        $dstmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $compurl=parse_url($url);
    if ($compurl['path']=='') {
        $url=$url."/";
    }
    $uquery = "UPDATE ".$mysql_table_prefix."sites SET url = ? , title = ? , "
      ."short_desc = ? , spider_depth = ? , required = ? , disallowed = ? , "
      ."usesitemap = ? , ignore_robots = ? , can_leave_domain = ? , "
      ."foreign_images = ?, link_log = ?, ct_lang = ? WHERE site_id = ? ";
    $ustmt = $db->prepare($uquery);
    if ($ustmt) {
        $ustmt->bind_param(
            "sssissiiiiisi", $url, $title, $short_desc, $depth,
            $required, $disallowed, $usesitemap, $ignore_robots, $domaincb,
            $foreignimgs, $linklog, $ctlang, $site_id
        );
        $ustmt->execute() or die("Execution failed: ".$ustmt->error);
        $ustmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $query = "SELECT category_id FROM ".$mysql_table_prefix."categories";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
        $sterror = 0;
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    while ($row = $result->fetch_array(MYSQLI_NUM)) {
        $cat_id = $row[0];
        if ($cat[$cat_id]=='on') {
            $iquery = "INSERT INTO ".$mysql_table_prefix."site_category "
              ."(site_id, category_id) values ( ?, ? )";
            $istmt = $db->prepare($iquery);
            if ($istmt) {
                $istmt->bind_param("ii", $site_id, $cat_id);
                $istmt->execute() or die("Execution failed: ".$istmt->error);
                $istmt->close();
            } else {
                trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
            }
        }
    }
    if (!$sterror) {
        return "<br><div style='text-align:center;'><b>Site updated.</b></div>" ;
    }
}


/**
 * Form to edit a category
 *
 * @param int $cat_id ID of the category being edited
 *
 * @return void
 */
function editCatForm($cat_id)
{
    global $mysql_table_prefix, $db, $key;

    $query = "SELECT category FROM ".$mysql_table_prefix."categories "
      ."WHERE category_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $cat_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->bind_result($category);
        $stmt->fetch();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    echo "<div style='text-align:center;' id='submenu'>
      <b>Edit category</b>
      </div>
      <br>
      <form action='admin.php' method='post'>
      <input type='hidden' name='f' value='10'>
      <input type='hidden' name='cat_id' value='".$cat_id."'>
      <input type=hidden name='Submit' value='".$key."'>
      <div class='stat_container' style='width:25%; border:none;'>
      <div class='row'><div class='stat_col' style='width:18%; border:none;
      text-align:left;'><b>Category:</b></div><div class='stat_col' style='width:82%;
      border:none; text-align:left;'><input type='text' name='category' value='"
      .$category."' size=40></div></div>
      <div class='row'><div class='stat_col' style='width:18%; border:none;'>
      </div><div class='stat_col' style='width:82%; border:none; text-align:left;'>
      <input type='submit' id='submit' value='Update'></div></div></div></form>";
}


/**
 * Edit a category
 *
 * @param int    $cat_id   ID of the category being edited
 * @param string $category Name of the category
 *
 * @return void
 */
function editCat($cat_id, $category)
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $query = "UPDATE ".$mysql_table_prefix."categories SET category = ? "
      ."WHERE category_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("si", $category, $cat_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->close();
        return "<br><div style='text-align:center;'><b>Category updated</b></div>";
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
}


/**
 * Show list of all sites
 *
 * @param string $message Informational message
 *
 * @return void
 */
function showSites($message)
{
    global $mysql_table_prefix, $db, $key;

    $query = "SELECT site_id, url, title, indexdate FROM ".$mysql_table_prefix
      ."sites ORDER BY indexdate, title";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    echo "<div id='submenu'>
      <ul>
      <li><a href='admin.php?f=add_site'>Add site</a> </li>";
    if ($result->num_rows > 0) {
        echo "<li><a href='spider.php?all=1&amp;Submit=".$key."'>
        Reindex all sites</a></li>";
    }
    echo "</ul>
      </div>"
      .$message
      ."<br>";
    if ($result->num_rows > 0) {
        echo "<div class='stat_container' style='width:55%;'>
          <div class='row' style='background-color:#f2f2f2;'>
          <div class='stat_col' style='width:25%; text-align:center;'><b>Site name
          </b></div><div class='stat_col' style='width:56%; text-align:center;'><b>
          Site url</b></div><div class='stat_col' style='width:12%;  
          text-align:center;'><b>Lastindexed</b></div><div class='stat_col' style=
          'width:7%;'></div></div>";
    } else {
        echo "<div style='text-align:center;'><p><b>Welcome to Sphider. <br>
            <br>Choose 'Add site' from the submenu to add a new site, 
            or 'Index' to directly go to the indexing section.</b></p></div>";
    }
    $bg_color = "#f2f2f2";
    while ($row = $result->fetch_array(MYSQLI_ASSOC)) {
        if ($row['indexdate']=='') {
            $indexstatus="<span style='color:red;'>Not indexed</span>";
            $indexoption="<a href='admin.php?f=index&amp;url="
              .urlencode($row['url'])."'>Index</a>";
        } else {
            $site_id = $row['site_id'];
            $query2 = "SELECT site_id FROM ".$mysql_table_prefix
              ."pending WHERE site_id = ? ";
            $stmt2 = $db->prepare($query2);
            if ($stmt2) {
                $stmt2->bind_param("i", $site_id);
                $stmt2->execute() or die("Execution failed: ".$stmt2->error);
                $result2 = $stmt2->get_result();
                $stmt2->close();
            } else {
                trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
            }
            $row2 = $result2->fetch_array(MYSQLI_ASSOC);
            if ($row2['site_id'] == $row['site_id']) {
                $indexstatus = "Unfinished";
                $indexoption="<a href='admin.php?f=index&amp;url="
                  .urlencode($row['url'])."'>Continue</a>";
            } else {
                $indexstatus = $row['indexdate'];
                $indexoption="<a href='admin.php?f=index&amp;url="
                  .urlencode($row['url'])."&reindex=1'>Re-index</a>";
            }
        }
        if ($bg_color =="white") {
            $bg_color = "#f2f2f2";
        } else {
            $bg_color = "white";
        }
        echo "<div class='row' style='background-color:".$bg_color.";'>
          <div class='stat_col' style='width:25%; text-align:left;'>"
          .htmlentities($row['title'] ?? '', ENT_QUOTES, 'UTF-8')."</div>
          <div class='stat_col' style='width:56%; text-align:left;'>
          <a href='".$row['url']."'>"
          .htmlentities($row['url'] ?? '', ENT_QUOTES, 'UTF-8')
          ."</a></div><div class='stat_col' style='width:12%; text-align:center;'>"
          .$indexstatus."</div>
          <div class='stat_col' style='width:7%; text-align:center;'>
          <a href='admin.php?f=20&amp;site_id=".$row['site_id']
          ."' class='small_button'>Options</a></div></div>";
    }
    if ($result->num_rows > 0) {
        echo "</div>";
    }
}


/**
 * Delete a category
 *
 * @param int $cat_id ID of the category to delete
 *
 * @return void
 */
function deleteCat($cat_id)
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $list = implode(",", getCats($cat_id));
    $query = "DELETE FROM ".$mysql_table_prefix."categories "
      ."WHERE category_id IN (".$list.")";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    return "<div style='text-align:center;'><b>Category deleted.</b></div>";
}


/**
 * Delete a site
 *
 * @param int $site_id ID of the site to be deleted
 *
 * @return void
 */
function deleteSite($site_id)
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $query = "DELETE FROM ".$mysql_table_prefix."sites WHERE site_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $site_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    return "<br><div style='text-align:center;'><b>Site deleted</b></div>";
}


/**
 * Clear a site's data
 *
 * @param int $site_id ID of the site to be cleared
 *
 * @return void
 */
function clearSite($site_id)
{
    global $mysql_table_prefix, $db, $Submit, $key;
    
    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $query = "UPDATE ".$mysql_table_prefix."sites SET indexdate = null "
      ."WHERE site_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $site_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $query = "DELETE FROM ".$mysql_table_prefix."links WHERE site_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $site_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }

    $query = "DELETE FROM ".$mysql_table_prefix."pending WHERE site_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $site_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }

    return "<br><div style='text-align:center;'><b>Site cleared</b></div>";
}


/**
 * Delete a page
 *
 * @param int $link_id ID of the page to be deleted
 *
 * @return void
 */
function deletePage($link_id)
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $query = "DELETE FROM ".$mysql_table_prefix."links WHERE link_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $link_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    return "<br><div style='test-align:center;'><b>Page deleted</b></div>";
}


/**
 * Function to truncate the temp table
 *
 * @return void
 */
function cleanTemp()
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $query = "DELETE FROM ".$mysql_table_prefix."temp WHERE level >= 0";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $del = $stmt->affected_rows;
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    echo "<div id='submenu'>
      </div>
      <br><div style='text-align:center;'><b>Temp table cleared, "
      .$del." items deleted.</b></div>";
}


/**
 * Function to truncate the query_log table
 *
 * @return void
 */
function clearLog()
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $query = "DELETE FROM ".$mysql_table_prefix."query_log WHERE time >= 0";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $del = $stmt->affected_rows;
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    echo "<div id='submenu'>
      </div>
      <br><div style='text-align:center;'><b>Search log cleared, "
      .$del." items deleted.</b></div>";
}


/**
 * Function to clean unassociated links
 *
 * @return void
 */
function cleanLinks()
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $todelete = array();
    $query = "SELECT site_id FROM ".$mysql_table_prefix."sites";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->bind_result($site_id);
        $stmt->store_result();
        if ($stmt->num_rows>0) {
            while ($stmt->fetch()) {
                $todelete[]=$site_id;
            }
            $todelete = implode(",", $todelete);
            $sql_end = " not in (".$todelete.")";
        }
        $stmt->free_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }

    $query = "SELECT link_id FROM ".$mysql_table_prefix
      ."links WHERE site_id".$sql_end;
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $del = $result->num_rows;
        while ($row = $result->fetch_array(MYSQLI_NUM)) {
            $link_id = $row[0];
            $query2 = "DELETE FROM ".$mysql_table_prefix
              ."links WHERE link_id = ? ";
            $stmt2 = $db->prepare($query2);
            if ($stmt2) {
                $stmt2->bind_param("i", $link_id);
                $stmt2->execute() or die("Execution failed: ".$stmt2->error);
                $stmt2->close();
            } else {
                trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
            }
        }
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }

    $query = "SELECT link_id FROM ".$mysql_table_prefix
      ."links WHERE site_id is null";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->bind_result($link_id);
        $stmt->store_result();
        $del += $stmt->num_rows;
        while ($stmt->fetch()) {
            $query2 = "DELETE FROM ".$mysql_table_prefix
              ."links WHERE link_id = ? ";
            $stmt2 = $db->prepare($query2);
            if ($stmt2) {
                $stmt2->bind_param("i", $link_id);
                $stmt2->execute() or die("Execution failed: ".$stmt2->error);
                $stmt2->close();
            } else {
                trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
            }
        }
        $stmt->free_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    echo "<div id='submenu'>
      </div>
      <br><div style='text-align:center;'><b>Links table cleaned, ".$del
      ." links deleted.</b></div>";
}


/**
 * Function to clear unassociated domains
 *
 * @return void
 */
function cleanDomains()
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $del = 0;
    $query = "SELECT url FROM ".$mysql_table_prefix."sites";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }

    $dom_arr = array();

    while ($row = $result->fetch_array(MYSQLI_ASSOC)) {
        $url_parts = parse_url($row['url']);
        $keep_domain = $url_parts['host'];
        $dom_arr[] = $keep_domain;
    }

    $list = "";

    $num_domains = count($dom_arr);
    for ($i=0; $i<$num_domains; $i++) {
        $list .= "'".$dom_arr[$i]."',";
    }

    $list = mb_substr($list ?? '', 0, mb_strlen($list ?? '', 'utf-8')-1, 'utf-8');

    if ($list != "") {
        $query = "SELECT * FROM ".$mysql_table_prefix
          ."domains WHERE domain NOT IN (".$list.")";
    } else {
        $query = "SELECT * FROM ".$mysql_table_prefix."domains";
    }
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }

    while ($row = $result->fetch_array(MYSQLI_ASSOC)) {
        $query = "DELETE FROM ".$mysql_table_prefix
          ."domains WHERE domain_id = ? ";
        $stmt = $db->prepare($query);
        if ($stmt) {
            $stmt->bind_param("i", $row['domain_id']);
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        $del++;
    }

    echo "<div id='submenu'>
      </div>
      <br><div style='text-align:center;'><b>Domains table cleaned, "
      .$del." domains deleted.</b></div>";
}


/**
 * Function to clear unassociated images
 *
 * @return void
 */
function cleanImages()
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $todelete = array();
    $query = "SELECT site_id FROM ".$mysql_table_prefix."sites";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->bind_result($site_id);
        $stmt->store_result();
        if ($stmt->num_rows>0) {
            while ($stmt->fetch()) {
                $todelete[]=$site_id;
            }
            $todelete = implode(",", $todelete);
            $sql_end = " not in (".$todelete.")";
        }
        $stmt->free_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }

    $query = "SELECT img_id FROM ".$mysql_table_prefix
      ."images WHERE site_id".$sql_end;
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $del = $result->num_rows;
        while ($row = $result->fetch_array(MYSQLI_NUM)) {
            $img_id = $row[0];
            $query2 = "DELETE FROM ".$mysql_table_prefix
              ."images WHERE img_id = ? ";
            $stmt2 = $db->prepare($query2);
            if ($stmt2) {
                $stmt2->bind_param("i", $img_id);
                $stmt2->execute() or die("Execution failed: ".$stmt2->error);
                $stmt2->close();
            } else {
                trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
            }
        }
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    echo "<div id='submenu'>
      </div>
      <br><div style='text-align:center;'><b>Images table cleaned, "
      .$del." images deleted.</b></div>";
}


/**
 * Function to clear unassociated RSS links
 *
 * @return void
 */
function cleanItems()
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $todelete = array();
    $query = "SELECT feed_id FROM ".$mysql_table_prefix."rss_sites";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->bind_result($feed_id);
        $stmt->store_result();
        if ($stmt->num_rows>0) {
            while ($stmt->fetch()) {
                $todelete[]=$feed_id;
            }
            $todelete = implode(",", $todelete);
            $sql_end = " not in (".$todelete.")";
        }
        $stmt->free_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }

    $query = "SELECT rss_id FROM ".$mysql_table_prefix
      ."rss_links WHERE feed_id".$sql_end;
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $del = $result->num_rows;
        while ($row = $result->fetch_array(MYSQLI_NUM)) {
            $rss_id = $row[0];
            $query2 = "DELETE FROM ".$mysql_table_prefix
              ."rss_links WHERE rss_id = ? ";
            $stmt2 = $db->prepare($query2);
            if ($stmt2) {
                $stmt2->bind_param("i", $rss_id);
                $stmt2->execute() or die("Execution failed: ".$stmt2->error);
                $stmt2->close();
            } else {
                trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
            }
        }
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    echo "<div id='submenu'>
      </div>
      <br><div style='text-align:center;'><b>RSS links table cleaned, "
      .$del." items deleted.</b></div>";
}


/**
 * Function to clear unassociated keywords
 *
 * @return void
 */
function cleanKeywords()
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $del = 0;
    $query = "SELECT keyword_id, keyword FROM ".$mysql_table_prefix."keywords";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    while ($row = $result->fetch_array(MYSQLI_ASSOC)) {
        $keyId = $row['keyword_id'];
        $keyword = $row['keyword'];
        $wordmd5 = mb_substr(md5($keyword) ?? '', 0, 1, 'utf-8');
        $query1 = "SELECT keyword_id FROM ".$mysql_table_prefix."link_keyword"
          .$wordmd5." WHERE keyword_id = ? ";
        $stmt1 = $db->prepare($query1);
        if ($stmt1) {
            $stmt1->bind_param("i", $keyId);
            $stmt1->execute() or die("Execution failed: ".$stmt1->error);
            $stmt1->bind_result($keyword_id);
            $stmt1->store_result();
            if ($stmt1->num_rows < 1) {
                $query2 = "DELETE FROM ".$mysql_table_prefix
                  ."keywords WHERE keyword_id = ? ";
                $stmt2 = $db->prepare($query2);
                if ($stmt2) {
                    $stmt2->bind_param("i", $keyId);
                    $stmt2->execute() or die("Execution failed: ".$stmt2->error);
                    $stmt2->close();
                } else {
                    trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
                }
                $del++;
            }
            $stmt1->free_result();
            $stmt1->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
    }
    echo "<div id='submenu'>
      </div>
      <br><div style='text-align:center;'><b>Keywords table cleaned, "
      .$del." keywords deleted.</b></div>";
}


/**
 * Function to generate database statistics
 *
 * @return void
 */
function getStatistics()
{
    global $mysql_table_prefix, $db;

    $stats = array();
    $keywordQuery = "SELECT COUNT(keyword_id) FROM "
      .$mysql_table_prefix."keywords";
    $linksQuery = "SELECT COUNT(url) FROM ".$mysql_table_prefix."links";
    $imgsQuery = "SELECT COUNT(imgUrl) FROM ".$mysql_table_prefix."images";
    $siteQuery = "SELECT COUNT(site_id) FROM ".$mysql_table_prefix."sites";
    $categoriesQuery = "SELECT COUNT(category_id) FROM ".$mysql_table_prefix
      ."categories";
    $feedQuery = "SELECT COUNT(feed_id) FROM ".$mysql_table_prefix."rss_sites";
    $itemsQuery = "SELECT COUNT(link) FROM ".$mysql_table_prefix."rss_links";
    $stmt = $db->prepare($keywordQuery);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    if ($row = $result->fetch_array(MYSQLI_NUM)) {
        $stats['keywords']=$row[0];
    }
    $stmt = $db->prepare($imgsQuery);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    if ($row = $result->fetch_array(MYSQLI_NUM)) {
        $stats['images']=$row[0];
    }
    $stmt = $db->prepare($linksQuery);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    if ($row = $result->fetch_array(MYSQLI_NUM)) {
        $stats['links']=$row[0];
    }
    for ($i=0;$i<=15; $i++) {
        $char = dechex($i);
        $linkkeywordQuery = "SELECT COUNT(link_id) FROM ".$mysql_table_prefix
          ."link_keyword".$char."";
        $stmt = $db->prepare($linkkeywordQuery);
        if ($stmt) {
             $stmt->execute() or die("Execution failed: ".$stmt->error);
            $result = $stmt->get_result();
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        if ($row = $result->fetch_array(MYSQLI_NUM)) {
            $stats['index']+=$row[0];
        }
    }
    $stmt = $db->prepare($siteQuery);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    if ($row = $result->fetch_array(MYSQLI_NUM)) {
        $stats['sites']=$row[0];
    }
    $stmt = $db->prepare($categoriesQuery);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    if ($row = $result->fetch_array(MYSQLI_NUM)) {
        $stats['categories']=$row[0];
    }
    $stmt = $db->prepare($feedQuery);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    if ($row = $result->fetch_array(MYSQLI_NUM)) {
        $stats['feeds']=$row[0];
    }
    $stmt = $db->prepare($itemsQuery);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    if ($row = $result->fetch_array(MYSQLI_NUM)) {
        $stats['items']=$row[0];
    }
    return $stats;
}


/**
 * Add a site to the database
 *
 * @param string $url        Site URL
 * @param string $title      Title of the site
 * @param string $short_desc Short description of the site
 * @param int    $cat        Category ID for the site
 *
 * @return void
 */
function addSite($url, $title, $short_desc, $cat)
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $short_desc = addslashes($short_desc);
    $title = addslashes($title);
    $compurl=parse_url("".$url);
    if ($compurl['path']=='') {
        $url=$url."/";
    }
    // We run this TWICE! This is because there may be TWO redirects,
    // the first to 'www' and the second to 'https'
    $url = checkRedirect($url); // Update url if http->https
    $url = checkRedirect($url); // Update url if http->https
    $query = "SELECT site_id from ".$mysql_table_prefix."sites WHERE url = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("s", $url);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->store_result();
        $rows = $stmt->num_rows;
        $stmt->free_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    if ($rows==0 ) {
        $query = "INSERT INTO ".$mysql_table_prefix
          ."sites (url, title, short_desc) VALUES ( ? , ? , ? )";
        $stmt = $db->prepare($query);
        if ($stmt) {
            $stmt->bind_param("sss", $url, $title, $short_desc);
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        $query = "SELECT site_id FROM ".$mysql_table_prefix
          ."sites WHERE url = ? ";
        $stmt = $db->prepare($query);
        if ($stmt) {
            $stmt->bind_param("s", $url);
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $stmt->bind_result($site_id);
            $stmt->fetch();
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        $query = "SELECT category_id FROM ".$mysql_table_prefix."categories";
        $stmt = $db->prepare($query);
        if ($stmt) {
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $stmt->bind_result($cat_id);
            $stmt->store_result();
            while ($stmt->fetch()) {
                if ($cat[$cat_id]=='on') {
                    $iquery = "INSERT INTO ".$mysql_table_prefix
                      ."site_category (site_id, category_id) VALUES ( ? , ? )";
                    $istmt = $db->prepare($iquery);
                    if ($istmt) {
                        $istmt->bind_param("ii", $site_id, $cat_id);
                        $istmt->execute()
                          or die("Execution failed: ".$istmt->error);
                        $istmt->close();
                    } else {
                        trigger_error(
                            'Statement failed : '
                            .$db->error, E_USER_ERROR
                        );
                    }
                }
            }
            $stmt->free_result();
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        $message =  "<br><div style='text-align:center;'><b>Site added</b></div>" ;
    } else {
        $message = "<div style='text-align:center;'><b>Site already in "
          ."database</b></div>";
    }
    return $message;
}


/**
 * Indexing Screen
 *
 * @param string $url     URL to be indexed
 * @param int    $reindex Flag indicating a re-index
 *
 * @return void
 */
function indexScreen($url, $reindex)
{
    global $mysql_table_prefix, $db, $key, $row, $ctlang;

    $row = array();
    $check = "";
    $levelchecked = "checked";
    $spider_depth = 2;
    if ($url=="") {
        $url = "http://";
        $advurl = "";
        $ignore = 0;
    } else {
        $advurl = $url;
        $query = "SELECT spider_depth, required, disallowed, usesitemap, "
          ."ignore_robots, can_leave_domain, foreign_images, link_log, ct_lang FROM "
          .$mysql_table_prefix."sites  WHERE url = ? ";
        $stmt = $db->prepare($query);
        if ($stmt) {
            $stmt->bind_param("s", $url);
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $stmt->bind_result(
                $depth, $req, $disallow, $usemap, $ignore_robots,
                $cld, $ifi, $link_log, $ct_lang
            );
            $stmt->store_result();
            $num_rows = $stmt->num_rows;
            $stmt->fetch();
            $stmt->free_result();
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        if ($num_rows > 0) {
            $spider_depth = $depth;
            if ($spider_depth == -1 ) {
                $fullchecked = "checked";
                $spider_depth ="";
                $levelchecked = "";
            }
            $must = $req;
            $mustnot = $disallow;
            $checksitemap = $usemap;
            $linklog = $link_log;
            $ctlang = $ct_lang;
            $ignore = $ignore_robots;
            $checkcan = $cld;
            $checkforeign = $ifi;
        }
    }
    $row['ct_lang'] = $ctlang;
    echo "<div id='submenu'>
      <ul>
      <li>";
    if ($must !="" || $mustnot !="" || $checksitemap == 1 || $ignore == 1
        || $checkcan == 1 || $checkforeign == 1 || $linklog == 1
    ) {
        $_SESSION['index_advanced']=1;
    }
    if ($_SESSION['index_advanced']==1) {
         echo "<a href='admin.php?f=index&amp;adv=0&amp;url=".urlencode($advurl)
           ."&amp;reindex=".$reindex."'>Hide advanced options</a>";
    } else {
        echo "<a href='admin.php?f=index&amp;adv=1&amp;url=".urlencode($advurl)
          ."&amp;reindex=".$reindex."'>Advanced options</a>";
    }
    echo "</li>
      </ul>
      </div>
      <br>
      <div id='indexoptions'>
      <form action='spider.php' method='post'>
      <input type=hidden name='usesitemap' value='0'>
      <input type=hidden name='linklog' value='0'>
      <input type=hidden name='ignore_robots' value='0'>
      <input type=hidden name='domaincb' value='0'>
      <input type=hidden name='foreignimgs' value='0'>
      <input type=hidden name='Submit' value='".$key."'>
      <div class='stat_container' style='width:100%; border:none;'>
      <div class='row'><div class='stat_col' style='width:30%; border:none;
      text-align:left'><b>Address:</b></div><div class='stat_col' style='width:70%;
      border:none; text-align:left;'><input type='text' name='url' size='48' value='"
      .$url."'></div></div>
      <div class='row'><div class='stat_col' style='width:30%; border:none;
      text-align:left; padding-top:20px; vertical-align:top;'><b>Indexing options:
      </b></div><div class='stat_col' style='width:70%; border:none;
      text-align:left;'>
      <input type='radio' name='soption' value='full' ".$fullchecked
      ."> Full<br>
      <input type='radio' name='soption' value='level' ".$levelchecked
      .">To depth: <input type='text' name='maxlevel' size='2' value='"
      .$spider_depth."'><br>";
    if ($reindex==1) {
        $check="checked";
    }
    echo "<input type='checkbox' name='reindex' value='1' ".$check."> Reindex<br>
      </div></div>";

    if ($_SESSION['index_advanced']==1) {
        if ($checksitemap==1) {
            $checksitemap="checked";
        }
        if ($linklog==1) {
            $linklog="checked";
        }
        if ($ignore==1) {
            $ignore="checked";
        }
        if ($checkcan==1) {
            $checkcan="checked";
        }
        if ($checkforeign==1) {
            $checkforeign="checked";
        }
        echo "<div class='row'><div class='stat_col' style='width:30%; border:none;'>
          </div><div class='stat_col' style='width:70%; border:none; text-align:
          left;'><input type='checkbox' name='usesitemap' value='1' "
          .$checksitemap."> Index using a sitemap, if available<br></div></div>
          <div class='row'><div class='stat_col' style='width:30%; border:none;'>
          </div><div class='stat_col' style='width:70%; border:none; text-align:
          left;'><input type='checkbox' name='linklog' value='1' "
          .$linklog."> Create a links report<br></div></div>
          <div class='row'><div class='stat_col' style='width:30%; border:none;'>
          </div><div class='stat_col' style='width:70%; border:none; text-align:
          left;'><input type='checkbox' name='ignore_robots' value='1' "
          .$ignore."> Ignore robots.txt for images (Not recommended)<br></div></div>
          <div class='row'><div class='stat_col' style='width:30%; border:none;'>
          </div><div class='stat_col' style='width:70%; border:none; 
          text-align:left;'><input type='checkbox' name='domaincb' value='1' "
          .$checkcan."> Spider can leave domain<br></div></div>
          <div class='row'><div class='stat_col' style='width:30%; border:none;'>
          </div><div class='stat_col' style='width:70%; border:none; 
          text-align:left;'><input type='checkbox' name='foreignimgs' value='1' "
          .$checkforeign."> Index foreign images<br><br>";
          commonTextLang();
          echo "</div></div><div class='row'><div class='stat_col' style='width:30%;
          border:none; text-align:left; padding-top:20px; vertical-align:top;'>
          <b>URL must include:</b></div><div class='stat_col' style='width:70%;
          border:none; text-align:left;'><textarea name=in cols=35 rows=2
          wrap='soft'>".$must."</textarea></div></div>
          <div class='row'><div class='stat_col' style='width:30%; border:none;
          textalign:left; padding-top:20px; vertical-align:top;'><b>
          URL must not include:</b></div><div class='stat_col' style='width:70%;
          border:none; text-align:left;'><textarea name=out cols=35 rows=2
          wrap='soft'>".$mustnot."</textarea></div></div>";
    }
    echo "<div class='row'><div class='stat_col' style='width:30%; border:none;'>
      </div><div class='stat+col' style='width:70%; border:none; text-align:left;'>
      <input type='submit' id='submit' value='Start indexing'></div></div>
      </div></form></div>";
    unset($_SESSION['index_advanced']);
}


/**
 * View site properties
 *
 * @param int    $site_id Site identification number
 * @param string $message Informational text
 *
 * @return void
 */
function siteScreen($site_id, $message)
{
    global $mysql_table_prefix, $db, $key;

    $query = "SELECT site_id, url, title, short_desc, indexdate FROM "
      .$mysql_table_prefix."sites WHERE site_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $site_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $row = $result->fetch_array(MYSQLI_ASSOC);
    $url = replaceAmpersand($row['url']);
    if ($row['indexdate']=='') {
        $indexstatus="<span style='color:red;'>Not indexed</span>";
        $indexoption="<a href='admin.php?f=index&amp;url=".urlencode($url)
          ."'>Index</a>";
    } else {
        $site_id = $row['site_id'];
        $stmt2 = $db->prepare(
            "SELECT site_id FROM ".$mysql_table_prefix
            ."pending WHERE site_id = ? "
        );
        if ($stmt2) {
            $stmt2->bind_param("i", $site_id);
            $stmt2->execute() or die("Execution failed: ".$stmt2->error);
            $result2 = $stmt2->get_result();
            $stmt2->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        $row2 = $result2->fetch_array(MYSQLI_ASSOC);
        if ($row2['site_id'] == $row['site_id']) {
            $indexstatus = "Unfinished";
            $indexoption="<a href='admin.php?f=index&amp;url=".urlencode($url)
              ."'>Continue indexing</a>";
        } else {
            $indexstatus = $row['indexdate'];
            $indexoption="<a href='admin.php?f=index&amp;url=".urlencode($url)
              ."&amp;reindex=1'>Re-index</a>";
        }
    }
    echo "<div id='submenu'>
      </div>"
      .$message
      ."<br>
      <div style='margin-left:auto; margin-right:auto; width:55%;'>
      <div class='row'><div style='width:80%; display:table-cell;
      vertical-align:top;'>
      <div class='stat_container' style='width:100%;'>
      <div class='row'><div class='stat_col' style='width:20%; text-align:left;
      background-color:#f2f2f2;'>URL</div><div class='stat_col' style='width:80%;
      text-align:left;'><a href='".$row['url']."'>"
      .htmlentities($row['url'] ?? '', ENT_QUOTES, 'UTF-8')."</a></div></div>
      <div class='row'><div class='stat_col' style='width:20%; text-align:left;
      background-color:#f2f2f2;'>Title:</div><div class='stat_col' style='width:80%;
      text-align:left'>".htmlentities($row['title'] ?? '', ENT_QUOTES, 'UTF-8')
      ."</div></div><div class='row'><div class='stat_col' style='width:20%;
      text-align:left; background-color:#f2f2f2;'>Description:</div>
      <div class='stat_col' style='width:80%; text-align:left;'>"
      .htmlentities($row['short_desc'] ?? '', ENT_QUOTES, 'UTF-8')
      ."</div></div><div class='row'><div class='stat_col'
      style='width:20%; text-align:left; background-color:#f2f2f2;'>Last Indexed:
      </div><div class='stat_col' style='width:80%; text-align:left;'>"
      .$indexstatus."</div></div>
      </div></div>
      <div style='width:20%; padding-left:10px; display:table-cell;'>
      <div id='vertmenu'>
     <ul>
      <li><a href='admin.php?f=edit_site&amp;site_id=".$row['site_id']
      ."'>Edit</a></li>
      <li>".$indexoption."</li>";
    if ($row['indexdate']!='') {
        echo "<li><a href='admin.php?f=28&amp;site_id=".$row['site_id']
          ."&amp;Submit=".$key
          ."' onclick=\"return confirm('Are you sure you want to clear? Index "
          ."data will be lost.')\">Clear site</a></li>";
    }
    echo "<li><a href='admin.php?f=21&amp;site_id=".$row['site_id']
      ."&amp;Submit=".$key."'>Browse pages</a></li>
      <li><a href='admin.php?f=30&amp;site_id=".$row['site_id']
      ."&amp;Submit=".$key."'>Browse images</a></li>
      <li><a href='admin.php?f=33&amp;site_id=".$row['site_id']
      ."&amp;Submit=".$key
      ."' onclick=\"return confirm('Are you sure you want to delete? All images"
      ." will be lost.')\">Delete all images</a></li>
      <li><a href='admin.php?f=48&amp;site_id=".$row['site_id']
      ."&amp;Submit=".$key."'>Create a sitemap</a></li>
      <li><a href='admin.php?f=5&amp;site_id=".$row['site_id']
      ."&amp;Submit=".$key
      ."' onclick=\"return confirm('Are you sure you want to delete? Index will "
      ."be lost.')\">Delete</a></li>
      <li><a href='admin.php?f=19&amp;site_id=".$row['site_id']
      ."&amp;Submit=".$key."'>Stats</a></li>
      </ul>
      </div></div>
      </div></div>
      <div class='clear'>
      </div>
      <br>";
}


/**
 * Function to generate site specific statistics
 *
 * @param int $site_id Numeric id of the site
 *
 * @return void
 */
function siteStats($site_id)
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $query = "SELECT url FROM ".$mysql_table_prefix."sites WHERE site_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $site_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    if ($row = $result->fetch_array(MYSQLI_NUM)) {
        $url = $row[0];
        $lastIndexQuery = "SELECT indexdate FROM ".$mysql_table_prefix
          ."sites WHERE site_id = ? ";
        $sumSizeQuery = "SELECT SUM(LENGTH(fulltxt)) FROM ".$mysql_table_prefix
          ."links WHERE site_id = ? ";
        $siteSizeQuery = "SELECT SUM(size) FROM ".$mysql_table_prefix
          ."links WHERE site_id = ? ";
        $linksQuery = "SELECT COUNT(*) FROM ".$mysql_table_prefix
          ."links WHERE site_id = ? ";
        $imgsQuery = "SELECT COUNT(*) FROM ".$mysql_table_prefix
          ."images WHERE site_id = ? ";
        $stmt = $db->prepare($lastIndexQuery);
        if ($stmt) {
            $stmt->bind_param("i", $site_id);
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $result = $stmt->get_result();
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        if ($row = $result->fetch_array(MYSQLI_NUM)) {
            $stats['lastIndex']=$row[0];
        }
        $stmt1 = $db->prepare($sumSizeQuery);
        if ($stmt1) {
            $stmt1->bind_param("i", $site_id);
            $stmt1->execute() or die("Execution failed: ".$stmt1->error);
            $result = $stmt1->get_result();
            $stmt1->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        if ($row = $result->fetch_array(MYSQLI_NUM)) {
            $stats['sumSize']=$row[0];
        }
        $stmt2 = $db->prepare($linksQuery);
        if ($stmt2) {
            $stmt2->bind_param("i", $site_id);
            $stmt2->execute() or die("Execution failed: ".$stmt2->error);
            $result = $stmt2->get_result();
            $stmt2->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        if ($row = $result->fetch_array(MYSQLI_NUM)) {
            $stats['links']=$row[0];
        }
        for ($i=0;$i<=15; $i++) {
            $char = dechex($i);
            $indexQuery = "SELECT COUNT(*) FROM ".$mysql_table_prefix."links, "
              .$mysql_table_prefix."link_keyword".$char." WHERE "
              .$mysql_table_prefix."links.link_id = ".$mysql_table_prefix
              ."link_keyword".$char.".link_id AND ".$mysql_table_prefix
              ."links.site_id = ? ";
            $stmt3 = $db->prepare($indexQuery);
            if ($stmt3) {
                $stmt3->bind_param("i", $site_id);
                $stmt3->execute() or die("Execution failed: ".$stmt3->error);
                $result = $stmt3->get_result();
                $stmt3->close();
            } else {
                trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
            }
            if ($row = $result->fetch_array(MYSQLI_NUM)) {
                $stats['index']+=$row[0];
            }
        }
        for ($i=0;$i<=15; $i++) {
            $char = dechex($i);
            $wordQuery = "SELECT COUNT(DISTINCT keyword) FROM "
              .$mysql_table_prefix."keywords, ".$mysql_table_prefix."links, "
              .$mysql_table_prefix."link_keyword".$char." WHERE "
              .$mysql_table_prefix."links.link_id = ".$mysql_table_prefix
              ."link_keyword".$char.".link_id AND ".$mysql_table_prefix
              ."links.site_id = ? AND ".$mysql_table_prefix
              ."keywords.keyword_id = ".$mysql_table_prefix."link_keyword"
              .$char.".keyword_id";
            $stmt4 = $db->prepare($wordQuery);
            if ($stmt4) {
                $stmt4->bind_param("i", $site_id);
                $stmt4->execute() or die("Execution failed: ".$stmt4->error);
                $result = $stmt4->get_result();
                $stmt4->close();
            } else {
                trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
            }
            if ($row = $result->fetch_array(MYSQLI_NUM)) {
                $stats['words']+=$row[0];
            }
        }
        $stmt5 = $db->prepare($siteSizeQuery);
        if ($stmt5) {
            $stmt5->bind_param("i", $site_id);
            $stmt5->execute() or die("Execution failed: ".$stmt5->error);
            $result = $stmt5->get_result();
            $stmt5->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        if ($row = $result->fetch_array(MYSQLI_NUM)) {
            $stats['siteSize']=$row[0];
        }
        $stmt6 = $db->prepare($imgsQuery);
        if ($stmt6) {
            $stmt6->bind_param("i", $site_id);
            $stmt6->execute() or die("Execution failed: ".$stmt6->error);
            $result = $stmt6->get_result();
            $stmt6->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        if ($row = $result->fetch_array(MYSQLI_NUM)) {
            $stats['images']=$row[0];
        }
        if ($stats['siteSize']=="") {
            $stats['siteSize'] = 0;
        }
        $stats['siteSize'] = number_format($stats['siteSize'], 2);
        echo "<div id='submenu'></div>
          <br><div class='stat_container' style='width:28%;'>
          <div class='row' style='background-color:#f2f2f2;'>
          <div class='stat_col' style='width:100%;text-align:center;'>
          Statistics for site <a href='admin.php?f=20&amp;site_id=".$site_id."'>"
          .htmlentities($url ?? '', ENT_QUOTES, 'UTF-8')."</a></div>
          </div>
          <div class='row' style='background-color:white;'>
          <div class='stat_col' style='width:73%; text-align:left;'>
          Last indexed:</div>
          <div class='stat_col' style='width:27%; text-align:center;'>"
          .htmlentities($stats['lastIndex'] ?? '', ENT_QUOTES, 'UTF-8')."</div>
          </div>
          <div class='row' style='background-color:#f2f2f2;'>
          <div class='stat_col' style='width:73%; text-align:left;'>
          Pages indexed:</div>
          <div class='stat_col' style='width:27%; text-align:center;'>"
          .htmlentities($stats['links'] ?? '', ENT_QUOTES, 'UTF-8')."</div>
          </div>
          <div class='row' style='background-color:white;'>
          <div class='stat_col' style='width:73%; text-align:left;'>
          Images indexed:</div>
          <div class='stat_col' style='width:27%; text-align:center;'>"
          .htmlentities($stats['images'] ?? '', ENT_QUOTES, 'UTF-8')."</div>
          </div>
          <div class='row' style='background-color:#f2f2f2;'>
          <div class='stat_col' style='width:73%; text-align:left;'>
          Total index size:</div>
          <div class='stat_col' style='width:27%; text-align:center;'>"
          .htmlentities($stats['index'] ?? '', ENT_QUOTES, 'UTF-8')."</div>
          </div>";
        $sum = number_format($stats['sumSize']/1024, 2);
        echo "<div class='row' style='background-color:white;'>
          <div class='stat_col' style='width:73%; text-align:left;'>
          Cached texts:</div>
          <div class='stat_col' style='width:27%; text-align:center;'>"
          .htmlentities($sum ?? '', ENT_QUOTES, 'UTF-8')."kb</div>
          </div>
          <div class='row' style='background-color:#f2f2f2;'>
          <div class='stat_col' style='width:73%; text-align:left;'>
          Total number of keywords:</div>
          <div class='stat_col' style='width:27%; text-align:center;'>"
          .htmlentities($stats['words'] ?? '', ENT_QUOTES, 'UTF-8')."</div>
          </div>
          <div class='row' style='background-color:white;'>
          <div class='stat_col' style='width:73%; text-align:left;'>
          Site size:</div>
          <div class='stat_col' style='width:27%; text-align:center;'>"
          .htmlentities($stats['siteSize'] ?? '', ENT_QUOTES, 'UTF-8')."kb</div>
          </div>
          </div>";
    }
}


/**
 * Browse a site's indexed pages
 *
 * @param int    $site_id  ID of the site
 * @param int    $start    Starting page to list
 * @param string $filter   Filter applied to pages
 * @param int    $per_page Number of links to list per page
 *
 * @return void
 */
function browsePages($site_id, $start, $filter, $per_page)
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $query = "SELECT url FROM ".$mysql_table_prefix."sites WHERE site_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $site_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->bind_result($url);
        $stmt->fetch();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $query_add = "";
    if ($filter != "") {
        $query_add = "AND url LIKE '%".$db->real_escape_string($filter)."%'";
    }
    $linksQuery = "SELECT COUNT(*) FROM ".$mysql_table_prefix
      ."links WHERE site_id = ? ".$query_add;
    $stmt = $db->prepare($linksQuery);
    if ($stmt) {
        $stmt->bind_param("i", $site_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $row = $result->fetch_array(MYSQLI_NUM);
    $numOfPages = $row[0];
    $from = ($start-1) * 10;
    $to = min(($start)*10, $numOfPages);
    $lfilter = "%".$db->real_escape_string($filter)."%";
    $linksQuery = "SELECT link_id, url FROM ".$mysql_table_prefix
      ."links WHERE site_id = ? AND url LIKE ? ORDER BY url LIMIT ? , ? ";
    $stmt = $db->prepare($linksQuery);
    if ($stmt) {
        $stmt->bind_param("isii", $site_id, $lfilter, $from, $per_page);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    echo "<div id='submenu'></div>
      <br>
      <div style='text-align:center;'>
      <b>Pages of site <a href='admin.php?f=20&amp;site_id=".$site_id."'>"
      .htmlentities($url ?? '', ENT_QUOTES, 'UTF-8')."</a></b><br>
      <form action='admin.php' method='post'>
      <p>
      Urls per page: <input type='text' name='per_page' size='3' value='"
      .$per_page."'>
      Url contains: <input type='text' name='filter' size='15' value='"
      .htmlentities($filter ?? '', ENT_QUOTES, 'UTF-8')."'>
      <input type='submit' id='submit' value='Filter'>
      <input type='hidden' name='start' value='1'>
      <input type='hidden' name='site_id' value='".$site_id."'>
      <input type='hidden' name='f' value='21'>
      <input type='hidden' name='Submit' value='".$key."'>
      </p>
      </form>
      <div class='stat_container' style='width:41%;'>";
    $bg_color = "white";
    while ($row = $result->fetch_array(MYSQLI_ASSOC)) {
        if ($bg_color =="white") {
            $bg_color = "#f2f2f2";
        } else {
            $bg_color = "white";
        }
        echo "<div class='row' style='background-color:".$bg_color."'>
          <div class='stat_col' style='width:92%; text-align:left;'>
          <a href='".$row['url']."'>"
          .htmlentities($row['url'] ?? '', ENT_QUOTES, 'UTF-8')."</a></div>
          <div class='stat_col' style='width:8%;'><a href='admin.php?link_id="
          .$row['link_id']."&amp;f=22&amp;site_id=".$site_id
          ."&amp;start=1&amp;filter=".$filter."&amp;per_page=".$per_page
          ."&amp;Submit=".$key."'>Delete</a></div>
          </div>";
    }
    echo "</div><br>";
    $pages = ceil($numOfPages / $per_page);
    $prev = $start - 1;
    $next = $start + 1;
    if ($pages > 0) {
        echo "<span style='text-align:center;'>Pages: ";
    }
    $links_to_next =10;
    $firstpage = $start - $links_to_next;
    if ($firstpage < 1) {
        $firstpage = 1;
    }
    $lastpage = $start + $links_to_next;
    if ($lastpage > $pages) {
        $lastpage = $pages;
    }

    for ($x=$firstpage; $x<=$lastpage; $x++) {
        if ($x<>$start) {
            echo "<a href='admin.php?f=21&amp;site_id=".$site_id."&amp;start="
              .$x."&amp;filter=".$filter."&amp;per_page="
              .$per_page."&amp;Submit=".$key."'>".$x."</a> ";
        } else {
            echo "<b>".$x." </b>";
        } 
    }
    print"</span></div>";

}


/**
 * Displays form with various table cleansing functions
 *
 * @return void
 */
function cleanForm()
{
    global $mysql_table_prefix, $db, $key;

    $stmt = $db->prepare(
        "SELECT COUNT(*) FROM "
        .$mysql_table_prefix."query_log"
    );
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    if ($row = $result->fetch_array(MYSQLI_NUM)) {
        $log = $row[0];
    }
    $stmt = $db->prepare("SELECT COUNT(*) FROM ".$mysql_table_prefix."temp");
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    if ($row = $result->fetch_array(MYSQLI_NUM)) {
        $temp = $row[0];
    }
    echo "<div id='submenu'>
      </div>
      <br><div class='stat_container' style='width:30%; background-color:
      #f2f2f2;'>
      <div class='row' style='text-align:left;'>
      <div class='stat_col' style='width:30%;'>
      <a href='admin.php?f=15&amp;Submit=".$key."' class='small_button'>
	  Clean keywords</a></div>
      <div class='stat_col' style='width:70%;'> Delete all keywords
      not associated with any link.</div>
      </div>
      <div class='row' style='text-align:left;'>
      <div class='stat_col' style='width:30%;'>
      <a href='admin.php?f=16&amp;Submit=".$key."' class='small_button'>
	  Clean links</a></div>
      <div class='stat_col' style='width:70%;'> Delete all links
      not associated with any site.</div>
      </div>
      <div class='row' style='text-align:left;'>
      <div class='stat_col' style='width:30%;'>
      <a href='admin.php?f=clean_doms&amp;Submit=".$key."' class='small_button'>
	  Clean domains</a></div>
      <div class='stat_col' style='width:70%;'> Delete all domains
      not associated with any site.</div>
      </div>
      <div class='row' style='text-align:left;'>
      <div class='stat_col' style='width:30%;'>
      <a href='admin.php?f=clean_imgs&amp;Submit=".$key."' 
	  class='small_button'>Clean images</a></div>
      <div class='stat_col' style='width:70%;'> Delete all images
      not associated with any site.</div>
      </div>
      <div class='row' style='text-align:left;'>
      <div class='stat_col' style='width:30%;'>
      <a href='admin.php?f=clean_feeds&amp;Submit=".$key."' 
	  class='small_button'>Clean feeds</a></div>
      <div class='stat_col' style='width:70%;'> Delete all items
      not associated with any RSS site.</div>
      </div>
      <div class='row' style='text-align:left;'>
      <div class='stat_col' style='width:30%;'>
      <a href='admin.php?f=17&amp;Submit=".$key."' 
	  class='small_button'>Clear temp table </a></div>
      <div class='stat_col' style='width:70%;'>".$temp." items in
      temporary table.</div>
      </div>
      <div class='row' style='text-align:left;'>
      <div class='stat_col' style='width:30%;'>
      <a href='admin.php?f=23&amp;Submit=".$key."' 
	  class='small_button'>Clear search log </a></div>
      <div class='stat_col' style='width:70%;'>".$log." items in
      search log.</div>
      </div>
      </div>";
}


/**
 * Page to display various statstical specifics
 *
 * @param string $type Which type of statistical data to display
 *
 * @return void
 */
function statisticsForm($type)
{
    global $mysql_table_prefix, $log_dir, $db, $Submit, $key, $map_dir;
    global $report_dir;
    echo "<div id='submenu'>
      <ul>
      <li><a href='admin.php?f=statistics&amp;type=keywords&amp;Submit="
      .$key."'>Top keywords</a></li>
      <li><a href='admin.php?f=statistics&amp;type=pages&amp;Submit="
      .$key."'>Largest pages</a></li>
      <li><a href='admin.php?f=statistics&amp;type=top_searches&amp;Submit="
      .$key."'>Most popular searches</a></li>
      <li><a href='admin.php?f=statistics&amp;type=log&amp;Submit="
      .$key."'>Search log</a></li>
      <li><a href='admin.php?f=statistics&amp;type=spidering_log&amp;Submit="
      .$key."'>Spidering logs</a></li>
      <li><a href='admin.php?f=statistics&amp;type=links_report&amp;Submit="
      .$key."'>Links reports</a></li>
      <li><a href='admin.php?f=statistics&amp;type=sitemaps&amp;Submit="
      .$key."'>Sitemaps</a></li>
      </ul>
      </div>";
    if ($type == "") {
        $stmt = $db->prepare(
            "SELECT SUM(LENGTH(fulltxt)) FROM "
            .$mysql_table_prefix."links"
        );
        if ($stmt) {
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $result = $stmt->get_result();
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        if ($row = $result->fetch_array(MYSQLI_NUM)) {
            $cachedSumSize = $row[0];
        }
        $cachedSumSize = number_format($cachedSumSize / 1024, 2);
        $stmt = $db->prepare(
            "SELECT SUM(size) FROM "
            .$mysql_table_prefix."links"
        );
        if ($stmt) {
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $result = $stmt->get_result();
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        if ($row = $result->fetch_array(MYSQLI_NUM)) {
            $sitesSize = $row[0];
        }
        if (!isset($siteSize)) {
            $siteSize = 0;
        }
        $sitesSize = number_format($sitesSize, 2);
        $stats = getStatistics();
        echo "<br>
          <div class='stat_container' style='width:25%;'>
          <div class='row' style='background-color:#f2f2f2;'>
          <div class='stat_col' style='width:60%; text-align:left;
          font-weight:bold;'>Sites:</div>
          <div class='stat_col' style='width:40%; text-align:center;'>"
          .$stats['sites']."</div>
          </div>
          <div class='row' style='background-color:white;'>
          <div class='stat_col' style='width:60%; text-align:left;
          font-weight:bold;'>Categories:</div>
          <div class='stat_col' style='width:40%; text-align:center;'>"
          .$stats['categories']."</div>
          </div>
          <div class='row' style='background-color:#f2f2f2;'>
          <div class='stat_col' style='width:60%; text-align:left;
          font-weight:bold;'>Keywords:</div>
          <div class='stat_col' style='width:40%; text-align:center;'>"
          .$stats['keywords']."</div>
          </div>
          <div class='row' style='background-color:white'>
          <div class='stat_col' style='width:60%; text-align:left;
          font-weight:bold;'>Keyword-link relations:</div>
          <div class='stat_col' style='width:40%; text-align:center;'>"
          .$stats['index']."</div>
          </div>
          <div class='row' style='background-color:white;'>
          <div class='stat_col' style='width:60%; text-align:left;
          font-weight:bold;'>Images:</div>
          <div class='stat_col' style='width:40%; text-align:center;'>"
          .$stats['images']."</div>
          </div>
          <div class='row' style='background-color:#f2f2f2;'>
          <div class='stat_col' style='width:60%; text-align:left;
          font-weight:bold;'>RSS sites:</div>
          <div class='stat_col' style='width:40%; text-align:center;'>"
          .$stats['feeds']."</div>
          </div>
          <div class='row' style='background-color:white'>
          <div class='stat_col' style='width:60%; text-align:left;
          font-weight:bold;'>RSS items:</div>
          <div class='stat_col' style='width:40%; text-align:center;'>"
          .$stats['items']."</div>
          </div>
          <div class='row' style='background-color:#f2f2f2;'>
          <div class='stat_col' style='width:60%; text-align:left;
          font-weight:bold;'>Cached
          texts total:</div>
          <div class='stat_col' style='width:40%; text-align:center;'>"
          .$cachedSumSize." kb</div>
          </div>
          <div class='row' style='background-color:white'>
          <div class='stat_col' style='width:60%; text-align:left;
          font-weight:bold;'>Sites size
          total:</div>
          <div class='stat_col' style='width:40%; text-align:center;'>"
          .$sitesSize." kb</div>
          </div>
          </div>";
    }
    if ($type=='keywords' && $Submit == $key) {
        $bg_color = "#f2f2f2";
        echo "<br><div class='stat_container' style='width:18%;'>
          <div class='row' style='background-color:#f2f2f2;'>
          <div class='stat_col' style='width:40%; text-align:center;
          font-weight:bold;'>Keywords</div>
          <div class='stat_col' style='width:60%; text-align:center;
          font-weight:bold;'>Occurances</div>
          </div>";
        for ($i=0;$i<=15; $i++) {
            $char = dechex($i);
            $stmt=$db->prepare(
                "SELECT keyword, COUNT(".$mysql_table_prefix
                ."link_keyword".$char.".keyword_id) AS x FROM "
                .$mysql_table_prefix."keywords, ".$mysql_table_prefix
                ."link_keyword".$char." WHERE ".$mysql_table_prefix
                ."keywords.keyword_id = ".$mysql_table_prefix."link_keyword"
                .$char.".keyword_id GROUP BY keyword ORDER BY x DESC LIMIT 30"
            );
            if ($stmt) {
                $stmt->execute() or die("Execution failed: ".$stmt->error);
                $result = $stmt->get_result();
                $stmt->close();
            } else {
                trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
            }
            while (($row = $result->fetch_array(MYSQLI_NUM))) {
                $topwords[$row[0]] = $row[1];
            }
        }
        arsort($topwords);
        $count = 0;
        foreach ($topwords as $word => $weight) {
            if ($bg_color == "white") {
                $bg_color = "#f2f2f2";
            } else {
                $bg_color = "white";
            }
            $count++;
            if ($count > 30) {
                break;
            }
            echo "<div class='row' style='background-color:".$bg_color."'>
              <div class='stat_col' style='text-align:center; width:40%;
              '>".$word."</div>
              <div class='stat_col' style='text-align:center; width:60%;
              '>".$weight."</div>
              </div>";
        }
        echo "</div>";
    }
    if ($type=='pages' && $Submit == $key) {
        $bg_color = "#f2f2f2";
        echo "<br><div class='stat_container' style='width:40%'>
          <div class='row' style='background-color:#f2f2f2;'>
          <div class='stat_col' style='width:85%; text-align:left;
          font-weight:bold;'>Page</div>
          <div class='stat_col' style='width:15%; text-align:center;
          font-weight:bold;'>Text size</div>
          </div>";
        $stmt = $db->prepare(
            "SELECT ".$mysql_table_prefix."links.link_id, "
            ."url, LENGTH(fulltxt)  AS x FROM ".$mysql_table_prefix
            ."links ORDER BY x DESC LIMIT 20"
        );
        if ($stmt) {
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $result = $stmt->get_result();
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        while ($row = $result->fetch_array(MYSQLI_NUM)) {
            if ($bg_color =="white") {
                $bg_color = "#f2f2f2";
            } else {
                 $bg_color = "white";
            }
            $url = $row[1];
            $sum = number_format($row[2]/1024, 2);
            echo "<div class='row' style='background-color:".$bg_color."'>
              <div class='stat_col' style='text-align:left; width:85%;'>
              <a href='".$url."'>".htmlentities($url ?? '', ENT_QUOTES, 'UTF-8')
              ."</a>
              </div>
              <div class='stat_col' style='text-align:center;'>".$sum."kb</div>
              </div>";
        }
        echo "</div>";
    }
    if ($type=='top_searches' && $Submit == $key) {
        $bg_color = "#f2f2f2";
        echo "<br><div class='stat_container' style='width:35%;'>
          <div class='row' style='background-color:#f2f2f2;'>
          <div class='stat_col' style='width:27%; text-align:left;
          font-weight:bold;'>Query</div>
          <div class='stat_col' style='width:10%; text-align:left;
          font-weight:bold;'>Count</div>
          <div class='stat_col' style='width:28%; text-align:left;
          font-weight:bold;'>Average results</div>
          <div class='stat_col' style='width:35%; text-align:left;
          font-weight:bold;'>Last queried</div>
          </div>";
        $stmt = $db->prepare(
            "SELECT query, COUNT(*) AS c, DATE_FORMAT(MAX(time),"
            ." '%Y-%m-%d %H:%i:%s'), AVG(results)  FROM "
            .$mysql_table_prefix."query_log GROUP BY query ORDER BY c DESC"
        );
        if ($stmt) {
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $result = $stmt->get_result();
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        while ($row = $result->fetch_array(MYSQLI_NUM)) {
            if ($bg_color =="white") {
                $bg_color = "#f2f2f2";
            } else {
                $bg_color = "white";
            }
            $word = $row[0];
            $times = $row[1];
            $date = $row[2];
            $avg = number_format($row[3], 1);
            echo "<div class='row' style='background-color:".$bg_color.";'>
              <div class='stat_col' style='text-align:left; width:27%;'>"
              .htmlentities($word ?? '', ENT_QUOTES, 'UTF-8', false)."</div>
              <div class='stat_col' style='text-align:center; width:10%;'>"
              .$times."</div>
              <div class='stat_col' style='text-align:center; width:28%;'>"
              .$avg."</div>
              <div class='stat_col' style='text-align:left; width:35%;'>"
              .$date."</div>
              </div>";
        }
        echo "</div>";
    }
    if ($type=='log' && $Submit == $key) {
        $bg_color = "#f2f2f2";
        echo "<br><div class='stat_container' style='width:35%;'>
          <div class='row' style='background-color:#f2f2f2;'>
          <div class='stat_col' style='width:25%; text-align:left;
          font-weight:bold;'>Query</div>
          <div class='stat_col' style='width:15%; text-align:left;
          font-weight:bold;'>Results</div>
          <div class='stat_col' style='width:35%; text-align:left;
          font-weight:bold;'>Queried at</div>
          <div class='stat_col' style='width:25%; text-align:left;
          font-weight:bold;'>Time taken</div>
          </div>";
        $stmt = $db->prepare(
            "SELECT query, DATE_FORMAT(time, '%Y-%m-%d %H:%i:%s'),"
            ." elapsed, results FROM ".$mysql_table_prefix
            ."query_log ORDER BY time DESC"
        );
        if ($stmt) {
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $result = $stmt->get_result();
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        while ($row = $result->fetch_array(MYSQLI_NUM)) {
            if ($bg_color =="white") {
                $bg_color = "#f2f2f2";
            } else {
                $bg_color = "white";
            }
            $word = $row[0];
            $time = $row[1];
            $elapsed = $row[2];
            $results = $row[3];
            echo "<div class='row' style='background-color:".$bg_color.";'>
              <div class='stat_col' style='text-align:left; width:25%;'>"
              .htmlentities($word ?? '', ENT_QUOTES, 'UTF-8', false)."</div>
              <div class='stat_col' style='text-align:center; width:15%;'>"
              .$results."</div>
              <div class='stat_col' style='text-align:left; width:35%;'>"
              .$time."</div>
              <div class='stat_col' style='text-align:center; width:25%;'>"
              .$elapsed."</div>
              </div>";
        }
        echo "</div>";
    }
    if ($type=='spidering_log' && $Submit == $key) {
        $bg_color = "#f2f2f2";
        $files = getDirContents($log_dir);
        if (count($files)>0) {
            echo "<br><div class='stat_container' style='width:28%;'>
              <div class='row' style='background-color:#f2f2f2;'>
              <div class='stat_col' style='width:32%; text-align:center;
              font-weight:bold;'>File</div>
              <div class='stat_col' style='width:25%; text-align:center;
              font-weight:bold;'>Date/Time</div>
              <div class='stat_col' style='width:25%; text-align:center;
              font-weight:bold;'>Size</div>
              <div class='stat_col' style='width:18%; text-align:left;
              font-weight:bold;'></div>
              </div>";
            for ($i=0; $i<count($files); $i++) {
                $file = $files[$i];
                $year = mb_substr($file ?? '', 0, 2, 'utf-8');
                $month = mb_substr($file ?? '', 2, 2, 'utf-8');
                $day = mb_substr($file ?? '', 4, 2, 'utf-8');
                $hour = mb_substr($file ?? '', 6, 2, 'utf-8');
                $minute = mb_substr($file ?? '', 8, 2, 'utf-8');
                $fsize = round(filesize("./".$log_dir."/".$file)/1024, 2);
                if ($bg_color =="white") {
                    $bg_color = "#f2f2f2";
                } else {
                    $bg_color = "white";
                }
                echo "<div class='row' style='background-color:".$bg_color.";'>
                  <div class='stat_col' style='text-align:left; width:32%;'>
                  <a href='".$log_dir."/".$file."' target='_blank'>"
                  .htmlentities($file ?? '', ENT_QUOTES, 'UTF-8')."</a></div>
                  <div class='stat_col' style='text-align:center; width:25%;'>"
                  .$year."-".$month."-".$day." ".$hour.":".$minute."</div>
                  <div class='stat_col' style='text-align:center; width=25%;'>"
                  .$fsize." kb</div>
                  <div class='stat_col' style='text-align:left; width:18%;'>
                  <a href='?f=delete_log&amp;file=".$file."&amp;Submit=".$key
                  ."' class='small_button'>Delete</a></div>
                  </div>";
            }
            echo "</div>";
        } else {
            echo "<br><br>
              <div style='text-align:center;'><b>No saved logs.</b></div>";
        }
    }
    if ($type=='links_report' && $Submit == $key) {
        $bg_color = "#f2f2f2";
        $files = getDirContents($report_dir);
        if (count($files)>0) {
            echo "<br><div class='stat_container' style='width:28%;'>
              <div class='row' style='background-color:#f2f2f2;'>
              <div class='stat_col' style='width:32%; text-align:center;
              font-weight:bold;'>File</div>
              <div class='stat_col' style='width:25%; text-align:center;
              font-weight:bold;'>Date/Time</div>
              <div class='stat_col' style='width:25%; text-align:center;
              font-weight:bold;'>Size</div>
              <div class='stat_col' style='width:18%; text-align:left;
              font-weight:bold;'></div>
              </div>";
            for ($i=0; $i<count($files); $i++) {
                $file = $files[$i];
                $year = mb_substr($file ?? '', 2, 2, 'utf-8');
                $month = mb_substr($file ?? '', 4, 2, 'utf-8');
                $day = mb_substr($file ?? '', 6, 2, 'utf-8');
                $hour = mb_substr($file ?? '', 8, 2, 'utf-8');
                $minute = mb_substr($file ?? '', 10, 2, 'utf-8');
                $fsize = round(filesize("./".$report_dir."/".$file)/1024, 2);
                if ($bg_color =="white") {
                    $bg_color = "#f2f2f2";
                } else {
                    $bg_color = "white";
                }
                echo "<div class='row' style='background-color:".$bg_color.";'>
                  <div class='stat_col' style='text-align:left; width:32%;'>
                  <a href='".$report_dir."/".$file."' target='_blank'>"
                  .htmlentities($file ?? '', ENT_QUOTES, 'UTF-8')."</a></div>
                  <div class='stat_col' style='text-align:center; width:25%;'>"
                  .$year."-".$month."-".$day." ".$hour.":".$minute."</div>
                  <div class='stat_col' style='text-align:center; width=25%;'>"
                  .$fsize." kb</div>
                  <div class='stat_col' style='text-align:left; width:18%;'>
                  <a href='?f=delete_report&amp;file=".$file."&amp;Submit=".$key
                  ."' class='small_button'>Delete</a></div>
                  </div>";
            }
            echo "</div>";
        } else {
            echo "<br><br>
              <div style='text-align:center;'><b>No saved reports.</b></div>";
        }
    }
    if ($type=='sitemaps' && $Submit == $key) {
        $bg_color = "#f2f2f2";
        $files = getDirContents("sitemaps");
        if (count($files)>0) {
            echo "<br><div class='stat_container' style='width:35%;'>
              <div class='row' style='background-color:#f2f2f2;'>
              <div class='stat_col' style='width:50%; text-align:center;
              font-weight:bold;'>File</div>
              <div class='stat_col' style='width:18%; text-align:center;
              font-weight:bold;'>Date</div>
              <div class='stat_col' style='width:18%; text-align:center;
              font-weight:bold;'>Size</div>
              <div class='stat_col' style='width:14%; text-align:left;
              font-weight:bold;'></div>
              </div>";
            for ($i=0; $i<count($files); $i++) {
                $file = $files[$i];
                $fdate = date('d M Y', filemtime($map_dir."/".$file));
                $fsize = round(filesize($map_dir."/".$file)/1024, 2);
                if ($bg_color =="white") {
                    $bg_color = "#f2f2f2";
                } else {
                    $bg_color = "white";
                }
                echo "<div class='row' style='background-color:".$bg_color.";'>
                  <div class='stat_col' style='text-align:left; width:50%;'>
                  <a href='".$map_dir."/".$file."' target='_blank'>"
                  .htmlentities($file ?? '', ENT_QUOTES, 'UTF-8')."</a></div>
                  <div class='stat_col' style='text-align:center; width:18%;'>"
                  .$fdate."</div>
                  <div class='stat_col' style='text-align:center; width:18%;'>"
                  .$fsize." kb</div>
                  <div class='stat_col' style='text-align:left; width:14%;'>
                  <a href='?f=delete_map&amp;file=".$file."&amp;Submit=".$key
                  ."' class='small_button'>Delete</a></div>
                  </div>";
            }
            echo "</div>";
        } else {
            echo "<br><br>
              <div style='text-align:center;'><b>No sitemaps.</b></div>";
        }
    }
}


/**
 * List url's of images for a site
 *
 * @param int    $site_id  ID of the site
 * @param int    $start    Starting point of listing
 * @param string $filter   Filter to apply to list
 * @param int    $per_page Number of links to list per page
 *
 * @return void
 */
function browseImages($site_id, $start, $filter, $per_page)
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $query = "SELECT url FROM ".$mysql_table_prefix."sites WHERE site_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $site_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->bind_result($url);
        $stmt->fetch();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $query_add = "";
    if ($filter != "") {
        $query_add = "AND imgUrl LIKE '%".$db->real_escape_string($filter)."%'";
    }
    $imgsQuery = "SELECT COUNT(*) FROM ".$mysql_table_prefix
      ."images WHERE site_id = ? ".$query_add;
    $stmt = $db->prepare($imgsQuery);
    if ($stmt) {
        $stmt->bind_param("i", $site_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $row = $result->fetch_array(MYSQLI_NUM);
    $numOfPages = $row[0];
    $from = ($start-1) * 10;
    $to = min(($start)*10, $numOfPages);
    $lfilter = "%".$db->real_escape_string($filter)."%";
    $imgsQuery = "SELECT img_id, imgUrl FROM ".$mysql_table_prefix
      ."images WHERE site_id = ? AND imgUrl LIKE ? ORDER BY imgUrl LIMIT ? , ? ";
    $stmt = $db->prepare($imgsQuery);
    if ($stmt) {
        $stmt->bind_param("isii", $site_id, $lfilter, $from, $per_page);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    echo "<div id='submenu'></div>
      <br>
      <div style='text-align:center;'>
      <b>Images on site <a href='admin.php?f=20&amp;site_id=".$site_id."'>"
      .htmlentities($url ?? '', ENT_QUOTES, 'UTF-8')."</a></b><br>
      <form action='admin.php' method='post'>
      <p>
      Urls per page: <input type='text' name='per_page' size='3' value='"
      .$per_page."'>
      Url contains: <input type='text' name='filter' size='15' value='"
      .htmlentities($filter ?? '', ENT_QUOTES, 'UTF-8')."'>
      <input type='submit' id='submit' value='Filter'>
      <input type='hidden' name='start' value='1'>
      <input type='hidden' name='site_id' value='".$site_id."'>
      <input type='hidden' name='f' value='30'>
      <input type='hidden' name='Submit' value='".$key."'>
      </p>
      </form>
      <div class='stat_container' style='width:41%;'>";
    $bg_color = "white";
    while ($row = $result->fetch_array(MYSQLI_ASSOC)) {
        if ($bg_color =="white") {
            $bg_color = "#f2f2f2";
        } else {
            $bg_color = "white";
        }
        echo "<div class='row' style='background-color:".$bg_color."'>
          <div class='stat_col' style='width:92%; text-align:left;'>
          <a href='".$row['imgUrl']."'>"
          .htmlentities($row['imgUrl'] ?? '', ENT_QUOTES, 'UTF-8')
          ."</a></div>
          <div class='stat_col' style='width:8%;'> <a href='admin.php?img_id="
          .$row['img_id']."&amp;f=31&amp;site_id=".$site_id
          ."&amp;start=1&amp;filter=".$filter."&amp;per_page="
          .$per_page."&amp;Submit=".$key."'>Delete</a></div>
          </div>";
    }
    echo "</div><br>";
    $pages = ceil($numOfPages / $per_page);
    $prev = $start - 1;
    $next = $start + 1;
    if ($pages > 0) {
        echo "<span style='text-align:center;'>Pages: "; 
    }
    $links_to_next =10;
    $firstpage = $start - $links_to_next;
    if ($firstpage < 1) {
        $firstpage = 1;
    }
    $lastpage = $start + $links_to_next;
    if ($lastpage > $pages) {
        $lastpage = $pages;
    }

    for ($x=$firstpage; $x<=$lastpage; $x++) {
        if ($x<>$start) {
            echo "<a href='admin.php?f=30&amp;site_id=".$site_id
              ."&amp;start=".$x."&amp;filter=".$filter."&amp;per_page="
              .$per_page."&amp;Submit=".$key."'>".$x."</a> ";
        } else {
            echo "<b>".$x." </b>"; 
        }
    }
    print"</span></div>";

}


/**
 * Delete an image
 *
 * @param int $img_id ID number of the image to delete
 *
 * @return void
 */
function deleteImage($img_id)
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $query = "DELETE FROM ".$mysql_table_prefix."images WHERE img_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $img_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    return "<br><div style='test-align:center;'><b>Image deleted</b></div>";
}


/**
 * Delete all images for a site
 *
 * @param int $site_id ID number of the site
 *
 * @return void
 */
function deleteImages($site_id)
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $query = "DELETE FROM ".$mysql_table_prefix."images WHERE site_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $site_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    return;
}


/**
 * Show list of RSS Sites
 *
 * @param string $message Informational text
 *
 * @return void 
 */
function showFeeds($message)
{
    global $mysql_table_prefix, $db, $key;

    $query = "SELECT feed_id, feed_url, feed_title, indexdate FROM "
      .$mysql_table_prefix."rss_sites ORDER BY indexdate, feed_title";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    echo "<div id='submenu'>
      <ul>
      <li><a href='admin.php?f=add_feed'>Add feed</a> </li>";
    if ($result->num_rows > 0) {
        echo "<li><a href='rss_spider.php?all=1&amp;Submit=".$key."'>
        Reindex all feeds</a></li>";
    }
    echo "</ul>
      </div>"
      .$message
      ."<br>";
    if ($result->num_rows > 0) {
        echo "<div class='stat_container' style='width:55%;'>
          <div class='row' style='background-color:#f2f2f2;'>
          <div class='stat_col' style='width:29%; text-align:center;'><b>
          Feed name</b></div><div class='stat_col' style='width:50%;
          text-align:center;'><b>Feed url</b></div><div class='stat_col'
          style='width:13%; text-align:center;'><b>Last indexed</b></div>
          <div class='stat_col' style='width:8%;'></div></div>";
    } else {
        echo "<div style='text-align:center;'><p><b>Welcome to Sphider. <br>
          <br>Choose 'Add feed' from the submenu to add a new feed.</b>
          </p></div>";
    }
    $br_color = "#f2f2f2";
    while ($row = $result->fetch_array(MYSQLI_ASSOC)) {
        if ($row['indexdate']=='') {
            $indexstatus="<span style='color:red;'>Not indexed</span>";
            $indexoption="<a href='admin.php?f=rssindex&amp;feed_url="
              .urlencode($row['feed_url'])."'>Index</a>";
        } else {
            $indexstatus = $row['indexdate'];
        }
        if ($bg_color =="white") {
            $bg_color = "#f2f2f2";
        } else {
            $bg_color = "white";
        }
        echo "<div class='row' style='background-color:".$bg_color."'>
          <div class='stat_col' style='width:29%; text-align:left;'>"
          .htmlentities($row['feed_title'] ?? '', ENT_QUOTES, 'UTF-8')
          ."</div><div class='stat_col' style='width:50%; text-align:left;'>
          <a href='".$row['feed_url']."'>"
          .htmlentities($row['feed_url'] ?? '', ENT_QUOTES, 'UTF-8')
          ."</a></div><div class='stat_col' style='width:13%;
          text-align:center;'>".$indexstatus."</div>";
        echo "<div class='stat_col' style='width:8%; text-align:center;'>
          <a href='admin.php?f=38&amp;feed_id=".$row['feed_id']
          ."' class='small_button'>Options</a></div></div>";
    }
    echo "</div>";
}


/**
 * Show RSS site details
 *
 * @param int    $feed_id ID number of the RSS feed
 * @param string $message Informational text
 *
 * @return void
 */
function feedScreen($feed_id, $message)
{
    global $mysql_table_prefix, $db, $key;

    $query = "SELECT feed_id, feed_url, feed_title, short_desc, indexdate FROM "
      .$mysql_table_prefix."rss_sites WHERE feed_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $feed_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $row = $result->fetch_array(MYSQLI_ASSOC);
    $feed_url = replaceAmpersand($row['feed_url']);
    if ($row['indexdate']=='') {
        $indexstatus="<span style='color:red;'>Not indexed</span>";
        $indexoption="<a href='admin.php?f=rssindex&amp;feed_url="
          .urlencode($feed_url)."'>Index</a>";
    } else {
        $indexstatus = $row['indexdate'];
        $indexoption="<a href='admin.php?f=rssindex&amp;feed_url="
          .urlencode($feed_url)."&amp;reindex=1'>Re-index</a>";
    }
    echo "<div id='submenu'>
      </div>"
      .$message
      ."<br>
      <div style='margin-left:auto; margin-right:auto; width:55%;'>
      <div class='row'><div style='width:80%; display:table-cell;
      vertical-align:top'>
      <div class='stat_container' style='width:100%;'>
      <div class='row'><div class='stat_col' style='width:20%; text-align:left;
      background-color:#f2f2f2;'>URL:</div><div class='stat_col' style='width:80%;
      text-align:left;'><a href='".$row['url']."'>"
      .htmlentities($row['feed_url'] ?? '', ENT_QUOTES, 'UTF-8')."</a></div></div>
      <div class='row'><div class='stat_col' style='width:20%; text-align:left;
      background-color:#f2f2f2;'>Title:</div><div class='stat_col' style='width:80%;
      text-align:left;'>".htmlentities($row['feed_title'] ?? '', ENT_QUOTES, 'UTF-8')
      ."</div></div><div class='row'><div class='stat_col' style='width:20%;
      text-align:left;'>Description:</div><div class='stat_col' style='width:80%;
      text-align:left;'>".htmlentities($row['short_desc'] ?? '', ENT_QUOTES, 'UTF-8')
      ."</div></div><div class='row'><div class='stat_col' style='width:29=0%;
      text-align:left; background=color:#f2f2f2;'>Last indexed:</div>
      <div class='stat_col' style='width:80%; text-align:left;'>"
      .$indexstatus."</div></div></div></div>
      <div style='width:20%; padding-left:10px; display:table-cell;'>
      <div id= 'vertmenu'>
      <ul>
      <li><a href='admin.php?f=edit_feed&amp;feed_id=".$row['feed_id']
      ."'>Edit</a></li>
      <li>".$indexoption."</li>";
    if ($row['indexdate']!='') {
        echo "<li><a href='admin.php?f=40&amp;feed_id=".$row['feed_id']
          ."&amp;Submit=".$key
          ."' onclick=\"return confirm('Are you sure you want to clear? Index "
          ."data will be lost.')\">Clear feed</a></li>";
    }
    echo "<li><a href='admin.php?f=41&amp;feed_id=".$row['feed_id']
      ."&amp;Submit=".$key."'>Browse items</a></li>
      <li><a href='admin.php?f=42&amp;feed_id=".$row['feed_id']
      ."&amp;Submit=".$key
      ."' onclick=\"return confirm('Are you sure you want to delete? Index will "
      ."be lost.')\">Delete</a></li>
      <li><a href='admin.php?f=prune_feed&amp;feed_id=".$row['feed_id']
      ."&amp;feed_title=".$row['feed_title']."&amp;Submit=".$key."'>Prune feed
      </a></li>
      <li><a href='admin.php?f=43&amp;feed_id=".$row['feed_id']
      ."&amp;Submit=".$key."'>Stats</a></li>
      </ul>
      </div></div>
      </div></div>
      <div class='clear'>
      </div>
      <br>";
}


/**
 * Form to add a RSS site
 *
 * @return void
 */
function addFeedForm()
{
    global $key;

    echo "<div style='text-align:center;' id='submenu'><b>Add a feed</b></div>
      <br><div>
      <form action=admin.php method=post>
      <input type=hidden name=f value=37>
      <input type=hidden name='Submit' value='".$key."'>
      <div class='stat_container' style='width:39%; border:none;'>
      <div class='row'><div class='stat_col' style='width:23%; border:none;
      text-align:left;'><b>Feed URL:</b></div>
      <div class='stat_col' style='width:77%; text-align:left; border:none;'>
      <input type=text name=feed_url size=60 value='http://'></div></div>
      <div class='row'><div class='stat_col' style='width:23%; border:none;
      text-align:left;'><b>Feed Title:</b></div>
      <div class='col_stat' style='width:77%; text-align:left; border:none;'>
      <input type=text name=feed_title size=60></div></div>
      <div class='row'><div class='stat_col' style='width:23%; border:none;
      text-align:left; padding-top:30px; vertical-align:top;'><b>Short description:
      </b></div>
      <div class='stat_col' style='width:77%; border:none; text-align:left;'>
      <textarea name=short_desc cols=45 rows=3 wrap='soft'></textarea></div></div>
      <div class='row'><div class='stat_col' style='width:23%; border:none;'>
      </div><div class='stat_col' style='width:77%; border:none; text-align:left;'>
      <input type=submit id='submit' value=Add></div></div></div></form></div>";
}


/**
 * Add A RSS feed
 *
 * @param string $url        URL of the RSS feed
 * @param string $title      Title of the RSS feed
 * @param string $short_desc Short description of the RSS feed
 *
 * @return void
 */
function addFeed($url, $title, $short_desc)
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $short_desc = addslashes($short_desc);
    $title = addslashes($title);
    $compurl=parse_url("".$url);
    if ($compurl['path']=='') {
        $url=$url."/";
    }
    $query = "SELECT feed_id from ".$mysql_table_prefix
      ."rss_sites WHERE feed_url = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("s", $url);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->store_result();
        $rows = $stmt->num_rows;
        $stmt->free_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    if ($rows==0 ) {
        $query = "INSERT INTO ".$mysql_table_prefix
          ."rss_sites (feed_url, feed_title, short_desc) VALUES ( ? , ? , ? )";
        $stmt = $db->prepare($query);
        if ($stmt) {
            $stmt->bind_param("sss", $url, $title, $short_desc);
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        $message =  "<br><div style='text-align:center;'><b>Feed added</b></div>";
    } else {
        $message = "<div style='text-align:center;'><b>Feed already in database"
          ."</b></div>";
    }
    return $message;
}


/**
 * Form to edit a RSS site
 *
 * @param int $feed_id ID number of the RSS feed
 *
 * @return void
 */
function editFeedForm($feed_id)
{
    global $mysql_table_prefix, $db, $key;

    $query = "SELECT feed_id, feed_url, feed_title, short_desc from "
      .$mysql_table_prefix."rss_sites where feed_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $feed_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $row = $result->fetch_array(MYSQLI_ASSOC);
    echo "<div style='text-align:center;' id='submenu'><b>Edit feed</b>
      </div>
      <br><div>
      <form action=admin.php method=post>
      <input type=hidden name=f value=44>
      <input type=hidden name=feed_id value=".$feed_id.">
      <input type=hidden name='Submit' value='".$key."'>
      <div class='stat_container' style='width:40%; border:none;'>
      <div class='row'><div class='stat_col' style='width:28%; border:none;
      text=align:left;'><b>Feed URL:</b></div><div class='stat_col' style='width:72%;
      border:none; text-align:left;'><input type=text name=feed_url value='"
      .htmlentities($row['feed_url'] ?? '', ENT_QUOTES, 'UTF-8')
      ."' size=60></div></div>
      <div class='row'><div class='stat_col' style='width:28%; border:none;
      text-align:left;'><b>Feed Title:</b></div><div class='stat_col'
      style='width:72%; border:none; text-align:left;'><input type=text
      name=feed_title value='"
      .htmlentities($row['feed_title'] ?? '', ENT_QUOTES, 'UTF-8')
      ."' size=60></div></div>
      <div class='row'><div class='stat_col' style='width:28%; border:none;
      text-align:left; padding-top:30px; vertical-align:top;'><b>Short description:
      </b></div><div class='stat+col' style='width:72%; border:none; text-align:
      left;'><textarea name=short_desc cols=45 rows=3 wrap>"
      .htmlentities($row['short_desc'] ?? '', ENT_QUOTES, 'UTF-8')
      ."</textarea></div></div>
      <div class='row'><div class='stat_col' style='width:28%; border:none;'>
      </div><div class='stat_col' style='width:72%; border:none; text-align:left;'>
      <input type='submit' id='submit' value='Update'></div></div></div>
      </form></div>";
}


/**
 * Edit RSS feed site
 *
 * @param int    $feed_id    ID number of the RSS feed
 * @param string $feed_url   URL of the RSS feed
 * @param string $feed_title Title of the RSS feed
 * @param string $short_desc Short description of the RSS feed
 *
 * @return void
 */
function editFeed($feed_id, $feed_url, $feed_title, $short_desc)
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $short_desc = addslashes($short_desc ?? '');
    $title = addslashes($title ?? '');
    $compurl=parse_url($url ?? '');
    if ($compurl['path']=='') {
        $url=$url."/";
    }
    $uquery = "UPDATE ".$mysql_table_prefix."rss_sites SET feed_url = ? , "
      ."feed_title = ? , short_desc = ? WHERE feed_id = ? ";
    $ustmt = $db->prepare($uquery);
    if ($ustmt) {
        $ustmt->bind_param("sssi", $feed_url, $feed_title, $short_desc, $feed_id);
        $ustmt->execute() or die("Execution failed: ".$ustmt->error);
        $ustmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    if (!$sterror) {
        return "<br><div style='text-align:center;'><b>Site updated.</b></div>" ;
    }
}


/**
 * Clear all items indexed for an RSS site
 *
 * @param int $feed_id ID number of the RSS feed
 *
 * @return void
 */
function clearFeed($feed_id)
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $query = "UPDATE ".$mysql_table_prefix."rss_sites SET indexdate = null "
      ."WHERE feed_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $feed_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }

    $query = "DELETE FROM ".$mysql_table_prefix."rss_links WHERE feed_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $feed_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }

    return "<br><div style='text-align:center;'><b>Feed cleared</b></div>";
}


/**
 * Browse list of RSS items for a feed
 *
 * @param in     $feed_id  ID number of the RSS feed
 * @param int    $start    Starting number of the items in the list
 * @param string $filter   Filter applied to the item urls
 * @param int    $per_page Number of items to list per page
 *
 * @return void
 */
function browseItems($feed_id, $start, $filter, $per_page)
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $query = "SELECT feed_url FROM ".$mysql_table_prefix
      ."rss_sites WHERE feed_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $feed_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->bind_result($feed_url);
        $stmt->fetch();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $query_add = "";
    if ($filter != "") {
        $query_add = "AND link LIKE '%".$db->real_escape_string($filter)."%'";
    }
    $linksQuery = "SELECT COUNT(*) FROM ".$mysql_table_prefix
      ."rss_links WHERE feed_id = ? ".$query_add;
    $stmt = $db->prepare($linksQuery);
    if ($stmt) {
        $stmt->bind_param("i", $feed_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $row = $result->fetch_array(MYSQLI_NUM);
    $numOfPages = $row[0];
    $from = ($start-1) * 10;
    $to = min(($start)*10, $numOfPages);
    $lfilter = "%".$db->real_escape_string($filter)."%";
    $linksQuery = "SELECT rss_id, link, title FROM ".$mysql_table_prefix
      ."rss_links WHERE feed_id = ? AND link LIKE ? ORDER BY pubDate "
      ."DESC LIMIT ? , ? ";
    $stmt = $db->prepare($linksQuery);
    if ($stmt) {
        $stmt->bind_param("isii", $feed_id, $lfilter, $from, $per_page);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    echo "<div id='submenu'>
      </div>
      <br>
      <div style='text-align:center;'>
      <b>Items of feed in <a href='admin.php?f=38&amp;feed_id=".$feed_id
      ."'>".htmlentities($feed_url ?? '', ENT_QUOTES, 'UTF-8')."</a></b><br>
      <form action='admin.php' method='post'>
      <p>
      Items per page: <input type='text' name='per_page' size='3' value='"
      .$per_page."'>
      Item contains: <input type='text' name='filter' size='15' value='"
      .htmlentities($filter ?? '', ENT_QUOTES, 'UTF-8')."'>
      <input type='submit' id='submit' value='Filter'>
      <input type='hidden' name='start' value='1'>
      <input type='hidden' name='feed_id' value='".$feed_id."'>
      <input type='hidden' name='f' value='41'>
      <input type='hidden' name='Submit' value='".$key."'>
      </p>
      </form>
      <div class='stat_container' style='width:41%;'>";
    $bg_color = "white";
    while ($row = $result->fetch_array(MYSQLI_ASSOC)) {
        if ($bg_color =="white") {
            $bg_color = "#f2f2f2";
        } else {
            $bg_color = "white";
        }
        echo "<div class='row' style='background-color:".$bg_color."'>
          <div class='stat_col'  style='width:92%; text-align:left;'>
          .<a href='".$row['link']."'>"
          .htmlentities($row['title'] ?? '', ENT_QUOTES, 'UTF-8')
          ."</a></div>
          <div class='stat_col' style='width:8%;'> <a href='admin.php?rss_id="
          .$row['rss_id']."&amp;f=22&amp;feed_id=".$feed_id
          ."&amp;start=1&amp;filter=".$filter."&amp;per_page="
          .$per_page."'>Delete</a></div>
          </div>";
    }
    echo "</div><br>";
    $pages = ceil($numOfPages / $per_page);
    $prev = $start - 1;
    $next = $start + 1;
    if ($pages > 0) {
        echo "<span style='text-align:center;'>Pages: "; 
    }
    $links_to_next =10;
    $firstpage = $start - $links_to_next;
    if ($firstpage < 1) {
        $firstpage = 1;
    }
    $lastpage = $start + $links_to_next;
    if ($lastpage > $pages) {
        $lastpage = $pages;
    }

    for ($x=$firstpage; $x<=$lastpage; $x++) {
        if ($x<>$start) {
            echo "<a href='admin.php?f=41&amp;feed_id=".$feed_id."&amp;start="
              .$x."&amp;filter=".$filter."&amp;per_page=".$per_page."&amp;Submit="
              .$key."'>".$x."</a> ";
        } else {
            echo "<b>".$x." </b>"; 
        }
    }
    print"</span></div>";

}


/**
 * Delete an RSS feed
 *
 * @param int $feed_id ID number of the RSS feed to delete
 *
 * @return void
 */
function deleteFeed($feed_id)
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $query = "DELETE FROM ".$mysql_table_prefix."rss_sites WHERE feed_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $feed_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    return "<br><div style='text-align:center;'><b>Feed deleted</b></div>";
}


/**
 * RSS feed specific statistics
 *
 * @param int $feed_id ID number of the RSS feed
 *
 * @return void
 */
function feedStats($feed_id)
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $query = "SELECT feed_url FROM ".$mysql_table_prefix
      ."rss_sites WHERE feed_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $feed_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    if ($row = $result->fetch_array(MYSQLI_NUM)) {
        $feed_url = $row[0];
        $lastIndexQuery = "SELECT indexdate FROM ".$mysql_table_prefix
          ."rss_sites WHERE feed_id = ? ";
        $linksQuery = "SELECT COUNT(*) FROM ".$mysql_table_prefix
          ."rss_links WHERE feed_id = ? ";
        $stmt = $db->prepare($lastIndexQuery);
        if ($stmt) {
            $stmt->bind_param("i", $feed_id);
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $result = $stmt->get_result();
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        if ($row = $result->fetch_array(MYSQLI_NUM)) {
            $stats['lastIndex']=$row[0];
        }
        $stmt2 = $db->prepare($linksQuery);
        if ($stmt2) {
            $stmt2->bind_param("i", $feed_id);
            $stmt2->execute() or die("Execution failed: ".$stmt2->error);
            $result = $stmt2->get_result();
            $stmt2->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
        if ($row = $result->fetch_array(MYSQLI_NUM)) {
            $stats['links']=$row[0];
        }
        echo "<div id='submenu'></div>
          <br><div class='stat_container' style='width:30%;'>
          <div class='row' style='background-color:#f2f2f2;'>
          <div class='stat_col' style='width:100%;text-align:center;'>
          Statistics for site <a href='admin.php?f=38&amp;feed_id=".$feed_id
          ."'>".htmlentities($feed_url ?? '', ENT_QUOTES, 'UTF-8')."</a></div>
          </div>
          <div class='row' style='background-color:white;'>
          <div class='stat_col' style='width:75%; text-align:left;'>
          Last indexed:</div>
          <div class='stat_col' style='width:25%; text-align:center;'>"
          .htmlentities($stats['lastIndex'] ?? '', ENT_QUOTES, 'UTF-8')."</div>
          </div>
          <div class='row' style='background-color:#f2f2f2;'>
          <div class='stat_col' style='width:75%; text-align:left;'>
          Pages indexed:</div>
          <div class='stat_col' style='width:25%; text-align:center;'>"
          .htmlentities($stats['links'] ?? '', ENT_QUOTES, 'UTF-8')."</div>
          </div></div>";
    }
}


/**
 * RSS index screen
 *
 * @param string $feed_url URl of the RSS feed to index
 * @param int    $reindex  Indicates if this is a re-index
 *
 * @return void
 */
function rssIndexScreen($feed_url, $reindex)
{
    global $mysql_table_prefix, $db, $key;

    echo "<div id='submenu'></div>
      <br><div id='indexoptions'>
      <form action='rss_spider.php' method='post'>
      <input type=hidden name='Submit' value='".$key."'>
      <div class='stat_container' style='width:100%; border:none;'>
      <div class='row'><div class='stat_col' style='width:30%; border:none;
      text-align:left''><b>Address:</b></div><div class='stat_col' style='width:70%;
      border:none; text-align:left;'><input type='text' name='feed_url' size='48'
       value='".$feed_url."'></div></div>
      <div class='row'><div class='stat_col' style='width:30%; border:none;'>
      </div><div class='stat+col' style='width:70%; border:none; text-align:left;'>
      <input type='submit' id='submit' value='Start indexing'></div></div>
      </div></form></div>";
}


/**
 * Screen from which outdated feed items may be deleted
 *
 * @param int    $feed_id    Numberic id of the RSS feed
 * @param string $feed_title Title of the RSS feed
 *
 * @return void
 */
function pruneFeedScreen($feed_id, $feed_title)
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    echo "<div id='submenu'>
      </div>
      <br>
      <div style='text-align:center;'>
      <b>Prune items in ".htmlentities($feed_title ?? '', ENT_QUOTES, 'UTF-8')
      ."</b><br>
      <form action='admin.php' method='post'>
      <p>
      Delete items older than <input type='text' name='age' size='3' "
      ."value='90'> days.
      <input type='hidden' name='feed_id' value='".$feed_id."'>
      <input type='hidden' name='f' value='47'>
      <input type='hidden' name='Submit' value='".$key."'>
      </p>
      <input type='submit' id='submit' value='Prune Feeds'>
      </form></div>";
}


/**
 * Delete dated RSS feed items
 *
 * @param int $feed_id Numeric id of the RSS feed
 * @param int $age     Age in days of items to delete
 *
 * @return void
 */
function pruneFeed($feed_id, $age)
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    $now=date('Y-m-d H:i:s');
    $date=date_create($now);
    date_sub($date, date_interval_create_from_date_string("$age days"));
    $then = date_format($date, "Y-m-d H:i:s");

    $query = "DELETE FROM ".$mysql_table_prefix
      ."rss_links WHERE pubDate < '".$then."' AND feed_id = ? ";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $feed_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $del = $stmt->affected_rows;
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    echo "<div id='submenu'>
      </div>
      <br><div style='text-align:center;'><b>".$del." items older than "
      .$age." days deleted.</b></div>";
}


/**
 * Create a sitemap from existing data
 *
 * @param int $site_id Numberic id of the Rsite id
 *
 * @return void
 */
function createSiteMap($site_id)
{
    global $mysql_table_prefix, $db, $Submit, $key;

    if (!isset($Submit) || $Submit != $key) {
        return;
    }
    
    $link_array = array();
    
    $query = "SELECT url FROM ".$mysql_table_prefix
      ."sites WHERE site_id = ?";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $site_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $row = $result->fetch_array(MYSQLI_ASSOC);
    $siteurl = $row['url'];
    $urlparts = parse_url($siteurl);
    $domain = $urlparts['host'];

    $query = "SELECT url FROM ".$mysql_table_prefix
      ."links WHERE site_id = ? ORDER BY url";
    $stmt = $db->prepare($query);
    if ($stmt) {
        $stmt->bind_param("i", $site_id);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }

    while ($row = $result->fetch_array(MYSQLI_ASSOC)) {
        $link_array[] = $row['url'];
    }
    
    if (count($link_array) == 0) {
        echo "<br><br><div style='text-align:center;'><b>No links in the 
          database. Create sitemap failed for ".$domain.".</b></div>";
        return;
    }

    if (!$file_handle = fopen("sitemaps/(".$domain.")-sitemap.xml", 'w')) {
        die("Cannot open file for writing.");
    }
    $text = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
    fwrite($file_handle, $text);
    $text = "<urlset xmlns=\"http://sitemaps.org/schemas/sitemap/0.9\">\n";
    fwrite($file_handle, $text);

    foreach ($link_array as $key => $url) {
        $text = "  <url>\n";
        fwrite($file_handle, $text);
        $url = htmlspecialchars(
            preg_replace_callback(
                '/[^\x20-\x7f]/',
                function ($match) {
                    return urlencode($match[0]); 
                }, $url
            )
        );
        $text = "    <loc>".$url."</loc>\n    <changefreq>monthly</changefreq>"
          ."\n    <priority>0.5</priority>\n";
        fwrite($file_handle, $text);
        $text = "  </url>\n";
        fwrite($file_handle, $text);
    }
    $text = "</urlset>\n";
    fwrite($file_handle, $text);
    fclose($file_handle);
    echo "<br><br><div style='text-align:center;'><b>sitemap-".$domain.".xml is
      completed.</b></div>";

}

$bad_url_chars = array('<','>','[',']','{','}','|','^','~','`','%','#');

switch (preg_replace('/[^a-z0-9_]/', '', $f ?? ''))
{
case 1:
    $message = addSite(
        str_replace($bad_url_chars, "", $url), $title,
        $short_desc, $cat
    );
    $compurl=parse_url($url);
    if ($compurl['path']=='') {
        $url=$url."/"; 
    }
    $url = str_replace($bad_url_chars, "", $url);
    $stmt = $db->prepare(
        "SELECT site_id FROM "
        .$mysql_table_prefix."sites WHERE url = ? "
    );
    if ($stmt) {
        $stmt->bind_param("s", $url);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $row = $result->fetch_array(MYSQLI_NUM);
    $site_id = $row[0];
    if ($site_id != "") {
        siteScreen(preg_replace('/[^0-9]/', '', $site_id ?? ''), $message); 
    } else {
        showSites($message);
    }
    break;
case 2:
    showSites('');
    break;
case 'edit_site':
    editSiteForm(preg_replace('/[^0-9]/', '', $site_id ?? ''));
    break;
case 4:
    if (!isset($usesitemap)) {
        $usesitemap = 0; 
    }
    if (!isset($domaincb)) {
        $domaincb = 0; 
    }
    if (!isset($foreignimgs)) {
        $foreignimgs = 0; 
    }
    if (!isset($cat)) {
        $cat = ""; 
    }
    if ($soption =='full') {
        $depth = -1;
    }
    $message = editSite(
        preg_replace('/[^0-9]/', '', $site_id ?? ''),
        str_replace($bad_url_chars, "", $url), $title, $short_desc, $depth, $in,
        $out, $usesitemap, $ignore_robots, $domaincb, $foreignimgs, $cat, $linklog,
        $ctlang
    );
    showSites($message);
    break;
case 5:
    deleteSite(preg_replace('/[^0-9]/', '', $site_id ?? ''));
    showSites('');
    break;
case 'add_cat':
    if (!isset($parent)) {
        $parent = ""; 
    }
    addCatForm($parent);
    break;
case 7:
    if (!isset($parent)) {
        $parent = "";
    }
    $message = addCat($category, $parent);
    listCats(0, 0, "white", $message);
    break;
case 'categories':
    listCats(0, 0, "white", "");
    break;
case 'edit_cat':
    editCatForm(preg_replace('/[^0-9]/', '', $cat_id ?? ''));
    break;
case 10:
    $message = editCat(preg_replace('/[^0-9]/', '', $cat_id ?? ''), $category);
    listCats(0, 0, "white", $message);
    break;
case 11:
    deleteCat(preg_replace('/[^0-9]/', '', $cat_id ?? ''));
    listCats(0, 0, "white", "");
    break;
case 'index':
    if (!isset($url)) {
        $url = ""; 
    }
    if (!isset($reindex)) {
        $reindex = ""; 
    }
    if (isset($adv)) {
        $_SESSION['index_advanced']=$adv;
    }
    indexScreen(str_replace($bad_url_chars, "", $url), $reindex);
    break;
case 'add_site':
    addSiteForm();
    break;
case 'clean':
    cleanForm();
    break;
case 15:
    cleanKeywords();
    break;
case 16:
    cleanLinks();
    break;
case 17:
    cleanTemp();
    break;
case 'statistics':
    if (!isset($type)) {
        $type = ""; 
    }
    statisticsForm(preg_replace('/[^a-z_]/', '', $type ?? ''));
    break;
case 19:
    siteStats(preg_replace('/[^0-9]/', '', $site_id ?? ''));
    break;
case 20:
    siteScreen(preg_replace('/[^0-9]/', '', $site_id ?? ''), '');
    break;
case 21:
    if (!isset($start)) {
        $start = 1; 
    }
    if (!isset($filter)) {
        $filter = ""; 
    }
    if (!isset($per_page)) {
        $per_page = 10; 
    }
    browsePages(
        preg_replace('/[^0-9]/', '', $site_id ?? ''), $start, $filter, $per_page
    );
    break;
case 22:
    deletePage(preg_replace('/[^0-9]/', '', $link_id ?? ''));
    if (!isset($start)) {
        $start = 1; 
    }
    if (!isset($filter)) {
        $filter = ""; 
    }
    if (!isset($per_page)) {
        $per_page = 10; 
    }
    browsePages(
        preg_replace('/[^0-9]/', '', $site_id ?? ''), $start, $filter, $per_page
    );
    break;
case 23:
    clearLog();
    break;
case 24:  // Log out
    session_unset();  // Remove session variables
    if (isset($_COOKIE['PHPSESSID'])) {
        // Remove session cookie
        setcookie("PHPSESSID", "", time() - 3600, "/");
    }
    session_destroy();  // End session
    echo "<script type='text/javascript'>
        window.open ('index.html','_self',false)
    </script>";
    break;
case 'database':
    include "db_main.php";
    break;
case 'settings':
    include 'configset.php';
    break;
case 'delete_log':
    unlink($log_dir."/".$file);
    statisticsForm('spidering_log');
    break;
case 28:
    clearSite(preg_replace('/[^0-9]/', '', $site_id ?? ''));
    showSites('');
    break;
case 'clean_feeds':
    cleanItems();
    break;
case 30:
    if (!isset($start)) {
        $start = 1; 
    }
    if (!isset($filter)) {
        $filter = ""; 
    }
    if (!isset($per_page)) {
        $per_page = 10; 
    }
    browseImages(
        preg_replace('/[^0-9]/', '', $site_id ?? ''), $start, $filter,
        $per_page
    );
    break;
case 31:
    deleteImage(preg_replace('/[^0-9]/', '', $img_id ?? ''));
    if (!isset($start)) {
        $start = 1; 
    }
    if (!isset($filter)) {
        $filter = ""; 
    }
    if (!isset($per_page)) {
        $per_page = 10; 
    }
    browseImages(
        preg_replace('/[^0-9]/', '', $site_id ?? ''), $start, $filter,
        $per_page
    );
    break;
case 'clean_doms':
    cleanDomains();
    break;
case 33:
    deleteImages(preg_replace('/[^0-9]/', '', $site_id ?? ''));
    siteScreen(preg_replace('/[^0-9]/', '', $site_id ?? ''), '');
    break;
case 'clean_imgs':
    cleanImages();
    break;
case 'show_feeds':
    showFeeds('');
    break;
case 'add_feed':
    addFeedForm();
    break;
case 37:
    $message = addFeed(
        str_replace($bad_url_chars, "", $feed_url), $feed_title,
        $short_desc
    );
    $compurl=parse_url($feed_url);
    if ($compurl['path']=='') {
        $f_url=$feed_url."/"; 
    }
    $url = str_replace($bad_url_chars, "", $feed_url);
    $stmt = $db->prepare(
        "SELECT feed_id FROM ".$mysql_table_prefix
        ."rss_sites WHERE feed_url = ? "
    );
    if ($stmt) {
        $stmt->bind_param("s", $feed_url);
        $stmt->execute() or die("Execution failed: ".$stmt->error);
        $result = $stmt->get_result();
        $stmt->close();
    } else {
        trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
    }
    $row = $result->fetch_array(MYSQLI_NUM);
    $feed_id = $row[0];
    if ($feed_id != "") {
        feedScreen(preg_replace('/[^0-9]/', '', $feed_id ?? ''), $message); 
    } else {
        showFeeds($message);
    }
    break;
case 38:
    feedScreen(preg_replace('/[^0-9]/', '', $feed_id ?? ''), '');
    break;
case 'edit_feed':
    editFeedForm(preg_replace('/[^0-9]/', '', $feed_id ?? ''));
    break;
case 40:
    clearFeed(preg_replace('/[^0-9]/', '', $feed_id ?? ''));
    showFeeds('');
    break;
case 41:
    if (!isset($start)) {
        $start = 1; 
    }
    if (!isset($filter)) {
        $filter = ""; 
    }
    if (!isset($per_page)) {
        $per_page = 10; 
    }
    browseItems(
        preg_replace('/[^0-9]/', '', $feed_id ?? ''), $start, $filter,
        $per_page
    );
    break;
case 42:
    deleteFeed(preg_replace('/[^0-9]/', '', $feed_id ?? ''));
    showFeeds('');
    break;
case 43:
    feedStats(preg_replace('/[^0-9]/', '', $feed_id ?? ''));
    break;
case 44:
    $message = editFeed(
        preg_replace('/[^0-9]/', '', $feed_id ?? ''),
        str_replace($bad_url_chars, "", $feed_url), $feed_title, $short_desc
    );
    showFeeds($message);
    break;
case 'rssindex':
    rssIndexScreen(str_replace($bad_url_chars, "", $feed_url), $reindex);
    break;
case 'prune_feed':
    pruneFeedScreen(preg_replace('/[^0-9]/', '', $feed_id ?? ''), $feed_title);
    break;
case 47:
    pruneFeed(
        preg_replace('/[^0-9]/', '', $feed_id ?? ''),
        preg_replace('/[^0-9]/', '', $age ?? '')
    );
    break;
case 48:
    createSiteMap(
        preg_replace('/[^0-9]/', '', $site_id ?? '') 
    );
    break;
case 'delete_map':
    unlink("sitemaps/".$file);
    statisticsForm('sitemaps');
    break;
case 'delete_report':
    unlink($report_dir."/".$file);
    statisticsForm('links_report');
    break;
case '':
    showSites('');
    break;
}

$stats = getStatistics();
echo "<br><br><div style='text-align:center;'>Currently in database: "
  .$stats['sites']." sites, ".$stats['links']." links, ".$stats['categories']
  ." categories, ".$stats['keywords']." keywords and ".$stats['images']
  ." images.<br>".$stats['feeds']." RSS feeds containing ".$stats['items']
  ." items.<br><br></div>
  </div>"; // End "main"
echo "</div>"; // End "admin"
echo "</body>
  </html>";
