<?php
/**
 * Sphider Version 5.5.*
 * Sphider is licensed under the GNU GPL.
 *
 * PHP version 5.4
 *
 * @category Sphider_Search
 * @package  Installation
 * @author   R. Prew  <CaptQ@blog.worldspaceflight.com>
 * @license  GNU GPL
 * @link     http://www.sphidersearch.com
 *
 * Original base code by:
 *   Ando Saabas  ando(a t)set.ee
 */
echo "<html>";
    echo "<head>";
    echo "<title>";
    echo "Sphider installation script.";
    echo "</title>";
    echo "<LINK REL=STYLESHEET HREF='admin.css' TYPE='text/css'>";
    echo "</head>";
echo "<body>";
echo "<h2>Sphider installation script.</h2>";

//error_reporting(E_ERROR | E_DEPRECATED); //Development only
error_reporting(0);
$settings_dir = "../settings";
require "$settings_dir/database.php";

$error = 0;

$db->query(
    "CREATE TABLE ".$mysql_table_prefix."sites(
    site_id int AUTO_INCREMENT NOT NULL PRIMARY KEY,
    url varchar(255),
    title varchar(255),
    short_desc text,
    indexdate date,
    spider_depth int DEFAULT 2,
    required text,
    disallowed text,
    usesitemap bool DEFAULT 0,
    ignore_robots bool DEFAULT 0,
    can_leave_domain bool DEFAULT 0,
    foreign_images bool DEFAULT 0,
    link_log bool DEFAULT 0,
    ct_lang varchar(10) NOT NULL DEFAULT 'en'
    ) ENGINE = InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci"
);

if ($db->errno > 0) {
    print "Error: ";
    print $db->error;
    print "<br>";
    $error += $db->errno;
}

$db->query(
    "CREATE TABLE ".$mysql_table_prefix."links (
    link_id int AUTO_INCREMENT PRIMARY KEY NOT NULL,
    site_id int,
    url varchar(255) NOT NULL,
    title varchar(200),
    description text,
    fulltxt longtext,
    indexdate date,
    size float(2),
    md5sum varchar(32),
    visible int DEFAULT 0,
    level int,
    key url (url),
    key md5key (md5sum),
    key site_id (site_id),
    CONSTRAINT links_ibfk_1 FOREIGN KEY (site_id) REFERENCES ".
    $mysql_table_prefix."sites (site_id) ON DELETE CASCADE ON UPDATE CASCADE
    ) ENGINE = InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci"
);

if ($db->errno > 0) {
    print "Error: ";
    print $db->error;
    print "<br>";
    $error += $db->errno;
}

$db->query(
    "CREATE TABLE ".$mysql_table_prefix."keywords    (
    keyword_id int PRIMARY KEY NOT NULL AUTO_INCREMENT,
    keyword varchar(35) NOT NULL,
    unique kw (keyword),
    key keyword (keyword(10))
    ) ENGINE = InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci"
);

if ($db->errno > 0) {
    print "Error: ";
    print $db->error;
    print "<br>";
    $error += $db->errno;
}

for ($i=0;$i<=15; $i++) {
    $char = dechex($i);
    $db->query(
        "CREATE TABLE ".$mysql_table_prefix."link_keyword".$char." (
        link_id int NOT NULL,
        keyword_id int NOT NULL,
        weight int(3),
        domain int(4),
        key linkid(link_id),
        key keyid(keyword_id),
        CONSTRAINT link_keyword".$char."_ibfk_1 FOREIGN KEY (link_id)
          REFERENCES ".$mysql_table_prefix."links (link_id) ON DELETE CASCADE
          ON UPDATE CASCADE,
        CONSTRAINT link_keyword".$char."_ibfk_2 FOREIGN KEY (keyword_id)
          REFERENCES ".$mysql_table_prefix."keywords (keyword_id) on delete
          cascade ON UPDATE CASCADE
        ) ENGINE = InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }
}

$db->query(
    "CREATE TABLE ".$mysql_table_prefix."categories (
    category_id integer NOT NULL AUTO_INCREMENT PRIMARY KEY,
    category text,
    parent_num integer
    ) ENGINE = InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci"
);

if ($db->errno > 0) {
    print "Error: ";
    print $db->error;
    print "<br>";
    $error += $db->errno;
}

$db->query(
    "CREATE TABLE ".$mysql_table_prefix."site_category (
    site_id integer,
    category_id integer,
    CONSTRAINT site_category_ibfk_1 FOREIGN KEY (site_id) REFERENCES ".
      $mysql_table_prefix."sites (site_id) ON DELETE CASCADE on update
      cascade
    ) ENGINE = InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci"
);

if ($db->errno > 0) {
    print "Error: ";
    print $db->error;
    print "<br>";
    $error += $db->errno;
}

$db->query(
    "CREATE TABLE ".$mysql_table_prefix."temp (
    link varchar(255),
    level integer,
    id varchar (32)
    ) ENGINE = InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci"
);

if ($db->errno > 0) {
    print "Error: ";
    print $db->error;
    print "<br>";
    $error += $db->errno;
}

$db->query(
    "CREATE TABLE ".$mysql_table_prefix."pending (
    site_id integer,
    temp_id varchar(32),
    level integer,
    count integer,
    num integer,
    key site_id (site_id),
    CONSTRAINT pending_ibfk_1 FOREIGN KEY (site_id) REFERENCES ".
      $mysql_table_prefix."sites (site_id) ON DELETE CASCADE ON UPDATE CASCADE
    ) ENGINE = InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci"
);

if ($db->errno > 0) {
    print "Error: ";
    print $db->error;
    print "<br>";
    $error += $db->errno;
}

$db->query(
    "CREATE TABLE ".$mysql_table_prefix."query_log (
    query varchar(255),
    time timestamp,
    elapsed float(2),
    results int,
    key query_key(query)
    ) ENGINE = InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci"
);

if ($db->errno > 0) {
    print "Error: ";
    print $db->error;
    print "<br>";
    $error += $db->errno;
}

$db->query(
    "CREATE TABLE ".$mysql_table_prefix."domains (
    domain_id int AUTO_INCREMENT PRIMARY KEY NOT NULL,
    domain varchar(255)
    ) ENGINE = InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci"
);

if ($db->errno > 0) {
    print "Error: ";
    print $db->error;
    print "<br>";
    $error += $db->errno;
}

$db->query(
    "CREATE TABLE ".$mysql_table_prefix."settings (
    id int AUTO_INCREMENT PRIMARY KEY NOT NULL,
    version_nr varchar(10),
    slanguage varchar(5),
    template varchar(15),
    admin_email varchar(45),
    print_results int,
    tmp_dir varchar(25),
    windows_os int,
    keep_log int,
    log_dir varchar(25),
    log_format varchar(15),
    email_log int,
    min_words_per_page int,
    min_word_length int,
    word_upper_bound int,
    index_numbers int,
    index_decimals int,
    dec_separator varchar(2),
    index_host int,
    index_meta_keywords int,
    index_images int,
    min_img_width int,
    min_img_height int,
    index_pdf int,
    index_doc int,
    index_xls int,
    index_ppt int,
    pdftotext_path varchar(45),
    catdoc_path varchar(45),
    xls2csv_path varchar(45),
    catppt_path varchar(45),
    pandoc_path varchar(45),
    user_agent varchar(50),
    min_delay int,
    pause_ int,
    pause_time int,
    pause_pages int,
    stem_words int,
    stem_language varchar(20),
    strip_sessids int,
    results_per_page int,
    cat_columns int,
    bound_search_result int,
    length_of_link_desc int,
    links_to_next int,
    qfloor int,
    show_meta_description int,
    advanced_search int,
    show_result_number int,
    show_index_date int,
    show_url int,
    show_query_scores int,
    show_stars int,
    show_categories int,
    desc_length int,
    merge_site_results int,
    did_you_mean_enabled int,
    classic_tab int,
    rss_tab int,
    image_tab int,
    suggest_enabled int,
    suggest_history int,
    suggest_keywords int,
    weighted_keywords int,
    suggest_phrases int,
    suggest_rows int,
    title_weight int,
    domain_weight int,
    path_weight int,
    meta_weight int
    ) ENGINE = InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci"
);

if ($db->errno > 0) {
    print "Error: ";
    print $db->error;
    print "<br>";
    $error += $db->errno;
}

$db->query(
    "CREATE TABLE ".$mysql_table_prefix."images(
    img_id int AUTO_INCREMENT NOT NULL PRIMARY KEY,
    imgUrl varchar(255),
    name varchar(255),
    width int,
    height int,
    alt varchar(255),
    site_id int,
    flag int,
    key site_id (site_id),
    CONSTRAINT images_ibfk_1 FOREIGN KEY (site_id) REFERENCES "
      .$mysql_table_prefix."sites (site_id) ON DELETE CASCADE ON UPDATE CASCADE
    ) ENGINE = InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci"
);

if ($db->errno > 0) {
    print "Error: ";
    print $db->error;
    print "<br>";
    $error += $db->errno;
}

$db->query(
    "CREATE TABLE ".$mysql_table_prefix."rss_sites (
    feed_id int AUTO_INCREMENT PRIMARY KEY NOT NULL,
    feed_url varchar(255),
    feed_title varchar(255),
    short_desc text,
    indexdate date
    ) ENGINE = InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci"
);

if ($db->errno > 0) {
    print "Error: ";
    print $db->error;
    print "<br>";
    $error += $db->errno;
}

$db->query(
    "CREATE TABLE ".$mysql_table_prefix."rss_links (
    rss_id int AUTO_INCREMENT PRIMARY KEY NOT NULL,
    feed_id int,
    title varchar(255),
    link varchar(255),
    pubDate datetime,
    key feed_id (feed_id),
    CONSTRAINT rss_links_ibfk_1 FOREIGN KEY (feed_id) REFERENCES "
      .$mysql_table_prefix."rss_sites (feed_id) ON DELETE CASCADE ON UPDATE
      CASCADE
    ) ENGINE = InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci"
);

if ($db->errno > 0) {
    print "Error: ";
    print $db->error;
    print "<br>";
    $error += $db->errno;
}

$db->query(
    "INSERT INTO ".$mysql_table_prefix."settings VALUES (1,'5.4.1','en',
    'standard','admin@admin.com',1,'tmp',0,1,'log','html',0,10,5,100,1,0,'.',0,1,0,
    50,50,0,0,0,0,'/usr/bin/pdftotext','/usr/bin/catdoc','/usr/bin/xls2csv',
    '/usr/bin/catppt','/usr/bin/pandoc','Sphider (sphidersearch.com)',0,0,120,30,0,
    'English',1,10,2,0,0,9,0,1,0,1,0,1,1,0,1,250,0,1,1,1,1,1,1,0,0,0,10,20,60,10,5)"
);

if ($db->errno > 0) {
    print "Error: ";
    print $db->error;
    print "<br>";
    $error += $db->errno;
}

if ($error >0) {
    print "<b>Creating tables failed. Consult the above error messages.</b>";
} else {
    print "<b>Creating tables successfully completed. Go to <a href=\"admin.php\">"
      ."admin.php</a> to start indexing.</b>";
}

echo "</body>";
echo "</html>";
