<?php
/**
 * Sphider Version 5.4.*
 * Sphider is licensed under the GNU GPL.
 *
 * PHP version 5.4
 *
 * @category Sphider_Search
 * @package  Admin
 * @author   R. Prew  <CaptQ@blog.worldspaceflight.com>
 * @license  GNU GPL
 * @link     http://www.sphidersearch.com
 *
 * Original base code by:
 *   Ando Saabas  ando(a t)set.ee
 */
//error_reporting(E_ERROR | E_DEPRECATED); //Development only
error_reporting(0);

$messages = Array (
    "noFollow" => Array (
        0 => " <span style='color:red'><b> No-follow flag set</b></span>. ",
        1 => " No-follow flag set."
    ),
    "inDatabase" => Array (
        0 => " <span style='color:red'><b> already in database</b></span><br>",
        1 => " already in database\n"
    ),
    "completed" => Array (
        0 => "<br>Completed at %cur_time.\n<br>",
        1 => "Completed at %cur_time.\n"
    ),
    "badfeed" => Array (
        0 => "<br>Feed not found.\n<br>",
        1 => "Feed not found.\n"
    ),
    "starting" => Array (
        0 => " Starting indexing at %cur_time.\n",
        1 => " Starting indexing at %cur_time.\n"
    ),
    "quit" => Array (
        0 => "</body></html>",
        1 => ""
    ),
    "pageRemoved" => Array (
        0 => " <span style='color:red'>Page removed from index.</span><br>\n",
        1 => " Page removed from index.\n"
    ),
    "continueSuspended" => Array (
        0 => "<br>Continuing suspended indexing.<br>\n",
        1 => "Continuing suspended indexing.\n"
    ),
    "indexed" => Array (
        0 => "<br> <b><span style='color:green'>Indexed</span></b><br>\n",
        1 => " \nIndexed\n"
    ),
    "rssindexed" => Array (
        0 => "<b> <span style='color:green'>Indexed</span></b><br>\n",
        1 => " Indexed\n"
    ),
    "duplicate" => Array (
        0 => " <span style='color:red'><b>Page is a duplicate.</b></span><br>\n",
        1 => " Page is a duplicate.\n"
    ),
    "md5notChanged" => Array (
        0 => " <span style='color:red'><b>MD5 sum checked. Page content not "
             ."changed</b></span><br>\n",
        1 => " MD5 sum checked. Page content not changed.\n"
    ),
    "metaNoindex" => Array (
        0 => " <span style='color:red'>No-Index flag set in meta tags.</span><br>\n",
        1 => " No-Index flag set in meta tags.\n"
    ),
    "re-indexed" => Array (
        0 => " <span style='color:green'>Re-indexed</span><br>\n",
        1 => " Re-indexed\n"
    ),
    "minWords" => Array (
        0 => " <span style='color:red'>Page contains less than $min_words_per_page "
             ."words</span><br>\n",
        1 => " Page contains less than $min_words_per_page words.\n"
    ),
    "useSiteMap" => Array (
        0 => " <span style='color:green'><b>Use sitemap.xml if available</b>"
             ."</span><br>\n",
        1 => " Use sitemap.xml if available.\n"
    ),
    "SiteMapUnavail" => Array (
        0 => " <span style='color:red;'>No usable sitemap.xml available"
             ."</span><br>\n",
        1 => " No usable sitemap.xml available.\n"
    ),
    "forbidden" => Array (
        0 => " <span style='color:red;'>Indexing forbidden by robots.txt"
             ."</span><br>\n",
        1 => " Indexing forbidden by robots.txt.\n"
    ),
    "duplicateImg" => Array (
        0 => " <span style='color:red;'>Image is a duplicate</span><br>\n",
        1 => " Image is a duplicate.\n"
    ),
    "imageRemoved" => Array (
        0 => " <span style='color:red;'>Image removed due to forbidden status"
             ."</span><br>\n",
        1 => " Image removed due to forbidden status.\n"
    ),
    "tooLong" => Array (
        0 => " <span style='color:red;'>Source URL too long for database"
             ."</span><br>\n",
        1 => " Source URL too long for database.\n"
    ),
    "tooSmall" => Array (
        0 => " <span style='color:red;'>Image too small to index</span><br>\n",
        1 => " Image too small to index.\n"
    )
);


/**
 * Robots Report
 *
 * @param int    $num      Link sequence number
 * @param string $thislink URL being indexed
 * @param int    $cl       Command line indicator
 *
 * @return void
 */
function printRobotsReport($num, $thislink, $cl)
{
    global $print_results, $log_format;
    $log_msg_txt = "$num. Link $thislink: file checking forbidden in robots.txt "
      ."file.\n";
    $log_msg_html = "<b>$num</b>. Link <b>$thislink</b>: <span style='color:red'>"
      ."file checking forbidden in robots.txt file</span></br>";
    if ($print_results) {
        if ($cl==0) {
            print $log_msg_html;
        } else {
            print $log_msg_txt;
        }
        flush();
    }
    if ($log_format=="html") {
        writeToLog($log_msg_html);
    } else {
        writeToLog($log_msg_txt);
    }
}


/**
 * URL String Report
 *
 * @param int    $num      Link sequence number
 * @param string $thislink URL being indexed
 * @param int    $cl       Command line indicator
 *
 * @return void
 */
function printUrlStringReport($num, $thislink, $cl)
{
    global $print_results, $log_format;

    if ($num == -1) {
        $log_msg_txt = " Indexing forbidden by required/disallowed string rule.\n";
        $log_msg_html = " <span style='color:red'>Indexing forbidden by "
          ."required/disallowed string rule</span></br>";
    } else {
        $log_msg_txt = "$num. Link $thislink: file checking forbidden by "
          ."required/disallowed string rule.\n";
        $log_msg_html = "<b>$num</b>. Link <b>$thislink</b>: "
          ."<span style='color:red'>file checking forbidden by required/disallowed"
          ." string rule</span></br>";
    }
    if ($print_results) {
        if ($cl==0) {
            print $log_msg_html;
        } else {
            print $log_msg_txt;
        }
        flush();
    }

    if ($log_format=="html") {
        writeToLog($log_msg_html);
    } else {
        writeToLog($log_msg_txt);
    }
}


/**
 * Page Being Retrieved
 *
 * @param int    $num      Link sequence number
 * @param string $thislink URL being indexed
 * @param int    $cl       Command line indicator
 *
 * @return void
 */
function printRetrieving($num, $thislink, $cl)
{
    global $print_results, $log_format, $img_ctr;

    if ($num == -1) {
        $img_ctr++;
        $log_msg_txt = "Image ".$img_ctr.". Retrieving: $thislink at "
          .date("H:i:s").".\n";
        $log_msg_html = "<b>Image ".$img_ctr."</b>. Retrieving: "
          ."<b>$thislink</b> at " . date("H:i:s").".\n";
    } else {
        $log_msg_txt = "$num. Retrieving: $thislink at " . date("H:i:s").".\n";
        $log_msg_html = "<b>$num</b>. Retrieving: <b>$thislink</b> at "
          .date("H:i:s").".<br>\n";
    }
    if ($print_results) {
        if ($cl==0) {
            print $log_msg_html;
        } else {
            print $log_msg_txt;
        }
        flush();
    }

    if ($log_format=="html") {
        writeToLog($log_msg_html);
    } else {
        writeToLog($log_msg_txt);
    }
}


/**
 * Page Links Report
 *
 * @param int $numoflinks Number of new links found
 * @param int $all_links  Total links found on page
 * @param int $cl         Command line indicator
 *
 * @return void
 */
function printLinksReport($numoflinks, $all_links, $cl)
{
    global $print_results, $log_format;
    $log_msg_txt = " Legit links found: $all_links. New links found: $numoflinks\n";
    $log_msg_html = " Links found: <span style='color:blue'><b>$all_links</b>"
      ."</span>. New links: <span style='color:blue'><b>$numoflinks</b>"
      ."</span><br>\n";
    if ($print_results) {
        if ($cl==0) {
            print $log_msg_html;
        } else {
            print $log_msg_txt;
        }
        flush();
    }

    if ($log_format=="html") {
        writeToLog($log_msg_html);
    } else {
        writeToLog($log_msg_txt);
    }
}


/**
 * URL Links Report
 *
 * @param string $url       URL being indexed
 * @param array  $links     Array of the found links
 * @param int    $all_links Total links found in URL
 *
 * @return void
 */
function printUrlLinkReport($url, $links, $all_links)
{
    sort($links);
    $report_msg_text = "<p>".$url;
    if ($all_links == 0) {
        $report_msg_text .= "<br>&nbsp;&nbsp;&nbsp;&nbsp;No links on this page.</p>";
    } else {
        foreach ($links as $key => $thislink) {
            $report_msg_text .= "<br>&nbsp;&nbsp;&nbsp;&nbsp;".$thislink;
        }
        $report_msg_text .= "</p>";
    }
    
    writeToReport($report_msg_text);
}


/**
 * Report Headers
 *
 * @param string $omit List of urls allowed or denied due to robots.txt
 * @param string $url  URL being omitted
 * @param int    $cl   Command line indicator
 * @param int    $f    0 indicates site, 1 indicates feed
 *
 * @return void
 */
function printHeader($omit, $url, $cl, $f)
{
    global $print_results, $log_format;

    if (is_array($omit['allow']) && count($omit['allow']) > 0 ) {
        $urlparts = parse_url($url);
        foreach ($omit['allow'] as $dir) {
            $permits[] = $urlparts['scheme']."://".$urlparts['host'].$dir;
        }
    }

    if (is_array($omit['deny']) && count($omit['deny']) > 0 ) {
        $urlparts = parse_url($url);
        foreach ($omit['deny'] as $dir) {
            $omits[] = $urlparts['scheme']."://".$urlparts['host'].$dir;
        }
    }
    
    $log_msg_txt = "Spidering $url\n";
    if (is_array($omit['allow']) && count($omit['allow']) > 0) {
        $log_msg_txt .= "Allowed files and directories in robots.txt:\n";
        $log_msg_txt .= implode("\n", $permits);
        $log_msg_txt .= "\n\n";
    }

    if (is_array($omit['deny']) && count($omit['deny']) > 0) {
        $log_msg_txt .= "Disallowed files and directories in robots.txt:\n";
        $log_msg_txt .= implode("\n", $omits);
        $log_msg_txt .= "\n\n";
    }

    $log_msg_html_1 = "<html><head><LINK REL=STYLESHEET HREF=\"admin.css\" "
      ."TYPE=\"text/css\"></head>\n";
    $log_msg_html_1 .= "<body style='font-family:Verdana, Arial; font-size:12px'>";

    if ($f == 0) {
        $log_msg_html_link = "[Back to <a href='admin.php'>admin</a>]";
    } else {
        $log_msg_html_link = "[Back to <a href='admin.php?f=show_feeds'>admin</a>]";
    }
    $log_msg_html_2 = "<p style='font-size:larger'>Spidering <b>$url</b></p>\n";

    if (is_array($omit['allow']) && count($omit['allow']) > 0) {
        $log_msg_html_2 .=  "Allowed files and directories in robots.txt:<br>\n";
        $log_msg_html_2 .=  implode("<br>", $permits);
        $log_msg_html_2 .=  "<br><br>";
    }

    if (is_array($omit['deny']) && count($omit['deny']) > 0) {
        $log_msg_html_2 .=  "Disallowed files and directories in robots.txt:<br>\n";
        $log_msg_html_2 .=  implode("<br>", $omits);
        $log_msg_html_2 .=  "<br><br>";
    }

    if ($print_results) {
        if ($cl==0) {
            print $log_msg_html_1.$log_msg_html_link.$log_msg_html_2;
        } else {
            print $log_msg_txt;
        }
        flush();
    }

    if ($log_format=="html") {
        writeToLog($log_msg_html_1.$log_msg_html_2);
    } else {
        writeToLog($log_msg_txt);
    }
}


/**
 * Images Being Indexed Report
 *
 * @param int $cl Command line indicator
 *
 * @return void
 */
function printImages($cl)
{
    global $print_results, $log_format;

    $log_msg_txt = "Images will be indexed\n";
    $log_msg_html = "<p style='color:blue;'><b>Images will be indexed</b></p>\n";

    if ($print_results) {
        print $log_msg_html;
        flush();
    }

    if ($log_format=="html") {
        writeToLog($log_msg_html);
    } else {
        writeToLog($log_msg_txt);
    }
}


/**
 * Robots being ignored report
 *
 * @param int $cl Command line indicator
 *
 * @return void
 */
function printNoRobot($cl)
{
    global $print_results, $log_format;

    $log_msg_txt = "WARNING: Robots.txt is being ignored for image indexing!\n";
    $log_msg_html = "<p style='color:red;'><b>WARNING: Robots.txt is being "
      ."ignored for image indexing!</b></p>\n";

    if ($print_results) {
        print $log_msg_html;
        flush();
    }

    if ($log_format=="html") {
        writeToLog($log_msg_html);
    } else {
        writeToLog($log_msg_txt);
    }
}


/**
 * Page Size Report
 *
 * @param int $pageSize Page size
 *
 * @return void
 */
function printPageSizeReport($pageSize)
{
    global $print_results, $log_format;
    $log_msg_txt = "Size of page: $pageSize"."kb. ";
    if ($print_results) {
        print $log_msg_txt;
        flush();
    }

    writeToLog($log_msg_txt);
}


/**
 * SURL Status Report
 *
 * @param string $report Status message
 * @param int    $cl     Command line indicator
 *
 * @return void
 */
function printUrlStatus($report, $cl)
{
    global $print_results, $log_format;
    $log_msg_txt = "$report\n";
    $log_msg_html = " <span style='color:red'><b>$report</b></span><br>\n";
    if ($print_results) {
        if ($cl==0) {
            print $log_msg_html;
        } else {
            print $log_msg_txt;
        }
        flush();
    }

    if ($log_format=="html") {
        writeToLog($log_msg_html);
    } else {
        writeToLog($log_msg_txt);
    }
}


/**
 * Connection Error Report
 *
 * @param string $errmsg Error message
 *
 * @return void
 */
function printConnectErrorReport($errmsg)
{
    global $print_results, $log_format;
    $log_msg_txt = "Establishing connection with socket failed. ";
    $log_msg_txt .= $errmsg;

    if ($print_results) {
        print $log_msg_txt;
        flush();
    }

    writeToLog($log_msg_txt);
}


/**
 * Write to Log file
 *
 * @param string $msg Log entry
 *
 * @return void
 */
function writeToLog($msg)
{
    global $keep_log, $log_handle;
    if ($keep_log) {
        if (!$log_handle) {
            die("Cannot open file for logging. ");
        }

        if (fwrite($log_handle, $msg) === false) {
            die("Cannot write to file for logging. ");
        }
    }
}


/**
 * Standard Report
 *
 * @param string $type Report type
 * @param int    $cl   Command line indicator
 *
 * @return void
 */
function printStandardReport($type, $cl)
{
    global $print_results, $log_format, $messages;
    if ($print_results) {
        print str_replace('%cur_time', date("H:i:s"), $messages[$type][$cl]);
        flush();
    }

    if ($log_format=="html") {
        writeToLog(str_replace('%cur_time', date("H:i:s"), $messages[$type][0]));
    } else {
        writeToLog(str_replace('%cur_time', date("H:i:s"), $messages[$type][1]));
    }
}


/**
 * Standard Link Report
 *
 * @param string $type Report type
 *
 * @return void
 */
function printStandardLinkReport($type)
{
    global $messages;
    
    writeToReport(str_replace('%cur_time', date("H:i:s"), $messages[$type][0]));
}


/**
 * Link Report Headers
 *
 * @param string $url URL being reported
 *
 * @return void
 */
function printLinkHeader($url)
{
    $log_msg_html_1 = "<html><head><LINK REL=STYLESHEET HREF=\"admin.css\" "
      ."TYPE=\"text/css\"></head>\n";
    $log_msg_html_1 .= "<body style='font-family:Verdana, Arial; font-size:12px'>";
    $log_msg_html_2 = "<p style='font-size:larger'>Link Report for <b>".
        $url."</b></p>\n";

    writeToReport($log_msg_html_1.$log_msg_html_2);
}


/**
 * Write to Report file
 *
 * @param string $msg Report entry
 *
 * @return void
 */
function writeToReport($msg)
{
    global $report_handle;
    if (!$report_handle) {
        die("Cannot open file for report. ");
    }

    if (fwrite($report_handle, $msg) === false) {
            die("Cannot write to file for report. ");
    }
}
