<?php
/**
 * Sphider Version 4.2.*
 * Sphider is licensed under the GNU GPL.
 *
 * PHP version 5.4
 *
 * @category Sphider_Search
 * @package  Search
 * @author   R. Prew  <CaptQ@blog.worldspaceflight.com>
 * @license  GNU GPL
 * @link     http://www.sphidersearch.com
 */
$adv_qry = "";
$type_qry = "";

echo "<br>";
extract($search_results);

$catid = $search_results['category'];

if ($search_results['did_you_mean']) {
    echo "<div id='did_you_mean'>";
    // WARNING - Getting fancy with sanitizing $search_results['did_you_mean']
    // will likely break PHRASE search suggestions.
    // It doesn't need sanitizing anyway.
    echo $sph_messages['DidYouMean'].": <a href='search.php?query="
      .quoteReplace($search_results['did_you_mean'])."&amp;search=1&amp;type="
      .$search_results['type']."&amp;category=".$catid."&amp;domain="
      .$domain."'>".$search_results['did_you_mean_b']."</a>?
      </div>";
}

if ($search_results['ignore_words']) {
    echo "<div id='common_report'>";
    foreach ($ignore_words as $thisword) {
        $ignored .= " ".$thisword;
    }
    $msg = str_replace('%ignored_words', $ignored, $sph_messages["ignoredWords"]);
    echo $msg
      ."</div>";
}

if ($search_results['total_results']==0) {
    echo "<div id ='result_report'>";
    // Fiddling with $ent_query to sanitize it is likely to distort the message!
    $msg = str_replace('%query', $ent_query, $sph_messages["noMatch"]);
    echo $msg
      ."</div>";
}

if ($total_results != 0 && $from <= $to) {
    echo "<div id ='result_report'>";
    $result = $sph_messages['Results'];
    $result = str_replace('%from', $from, $result);
    $result = str_replace('%to', $to, $result);
    $result = str_replace('%all', $total_results, $result);
    $matchword = $sph_messages["matches"];
    if ($total_results== 1) {
        $matchword= $sph_messages["match"];
    } else {
        $matchword= $sph_messages["matches"];
    }

    $result = str_replace('%matchword', $matchword, $result);
    $result = str_replace('%secs', $time, $result);
    echo $result
      ."</div>";
}

if (isset($qry_results)) {
    echo "<div id='results'>";
    // results listing
    foreach ($qry_results as $_key => $_row) {
        $last_domain = $domain_name;
        extract($_row);
        if ($show_result_number == 0) {
            $num = "";
        } else {
            $num = "<b>".$num.".</b> ";
        }
        if ($show_query_scores == 0) {
            $weight = '';
        } elseif ($show_stars == 0) {
            $weight = "[".$weight."%] ";
        } else {
            $star = (int)(($weight + 5) / 10);
            $weight = "<img src='".$img_dir."/star".$star.".png'
              alt='[".$weight."%]' title='[".$weight."%]'> ";
        }
        if ($domain_name==$last_domain && $merge_site_results == 1
            && $domain == ""
        ) {
            echo "<div class='idented'>";
        }
        echo $num.$weight;
        echo "<a href='".$url."' target='_blank' class='title'>"
          .($title?$title:$sph_messages['Untitled'])."</a><br>";
        if (isset($sph_messages['kb'])) {
            $page_size = $page_size." ".$sph_messages['kb'];
        } else {
            $page_size = $page_size." kb";
        }
        if ($show_index_date == 1) {
            echo "<div class='index_date'>".$indexdate." (".$page_size.")</div><br>";
        } else {
            echo "<div class='index_date'></div>";
        }
        echo "<div class='description'>".stripslashes($fulltxt)."</div><br>";
        if ($show_url == 1) {
            if ($show_index_date == 0) {
                echo "<div class='url'>".$url2." - ".$page_size."</div>";
            } else {
                echo "<div class='url'>".$url2."</div>";
            }
        } else {
            echo "<div class='url'></div>";
        }
        if ($domain_name==$last_domain && $merge_site_results == 1
            && $domain == ""
        ) {
            echo "[ <a href='search.php?query=".strip_tags($query ?? '')
              ."&amp;search=1&amp;results=".$results_per_page."&amp;domain="
              .$domain_name."'>More results from ".$domain_name."</a> ]
              </div class='idented'>";
        }
        echo "<br>";
    }
    echo "</div>";
}

// links to other result pages
if (isset($other_pages)) {
    if ($adv==1) {
        $adv_qry = "&amp;adv=1";
    }
    if ($type != "") {
        $type_qry = "&amp;type=$type";
    }

    echo "<div id='other_pages'>"
      .$sph_messages["Result page"].": ";
    if ($start >1) {
        echo "<a href=\"search.php?s=1&amp;query=".strip_tags($query ?? '')
          ."&amp;category=".$catid."&amp;start=".$prev
          ."&amp;search=1&amp;results=".$results_per_page.$type_qry.$adv_qry
          ."&amp;domain=".$domain."&amp;activesearch=1\">"
          .$sph_messages['Previous']."</a> ";
    }

    foreach ($other_pages as $page_num) {
        if ($page_num !=$start) {
            echo "<a href=\"search.php?s=1&amp;query=".strip_tags($query ?? '')
              ."&amp;category=".$catid."&amp;start=".$page_num
              ."&amp;search=1&amp;results=".$results_per_page.$type_qry.
              $adv_qry."&amp;domain=".$domain."&amp;activesearch=1\">"
              .$page_num."</a> ";
        } else {
            echo " <b>".$page_num."</b> ";
        }
    }

    if ($next <= $pages) {
        echo "<a href=\"search.php?s=1&amp;query=".strip_tags($query ?? '')
          ."&amp;category=".$catid."&amp;start="
          .$next."&amp;search=1&amp;results=".$results_per_page.$type_qry
          .$adv_qry."&amp;domain=".$domain."&amp;activesearch=1\">"
          .$sph_messages['Next']."</a> ";
    }
    echo "</div>";

}

echo "<br>
  <div class='bottom_container'>
  <form action='search.php'>
  <input type='hidden' name='s' value='1'>
  <input type='hidden' name='activesearch' value='0'>
  <input type='submit' class='button' value='".$sph_messages['Reset']
    ."'></form></div>";

echo "<div class='divline'>
  </div>
  <div id='powered_by'>";
poweredBy();
echo "</div>";
