<?php
/**
 * Sphider Version 4.2.*
 * Sphider is licensed under the GNU GPL.
 *
 * PHP version 5.4
 *
 * @category Sphider_Search
 * @package  Search
 * @author   R. Prew  <CaptQ@blog.worldspaceflight.com>
 * @license  GNU GPL
 * @link     http://www.sphidersearch.com
 *
 * Original base code by:
 *   Ando Saabas  ando(a t)cs.ioc.ee
 */

/**
 * Get Category View
 *
 * @return array $categories Array of categories
 */
function getCategoriesView()
{
    global $mysql_table_prefix;

    $categories['main_list'] = sqlFetchAll(
        'SELECT * FROM '
        .$mysql_table_prefix.'categories WHERE parent_num=0 ORDER BY category'
    );
        
    if (is_array($categories['main_list'])) {
        foreach ($categories['main_list'] as $_key => $_val) {
            $categories['main_list'][$_key]['sub'] =  sqlFetchAll(
                'SELECT * FROM '.$mysql_table_prefix
                .'categories WHERE parent_num='.$_val['category_id']
            );
        }
    }
    return $categories;
}


/**
 * Get category information
 *
 * @param int $catid Category id
 *
 * @return array $categories Array of category information
 */
function getCategoryInfo($catid)
{
    global $mysql_table_prefix;
    
    $categories['main_list'] = sqlFetchAll(
        "SELECT * FROM "
        .$mysql_table_prefix."categories ORDER BY category"
    );
    
    if (is_array($categories['main_list'])) {
        foreach ($categories['main_list'] as $_val) {
            $categories['categories'][$_val['category_id']] = $_val;
            $categories['subcats'][$_val['parent_num']][] = $_val;
        }
    }
    
    $categories['subcats']
        = $categories['subcats'][strip_tags($_REQUEST['catid'] ?? '')];
    
    /* count sites */
    if (is_array($categories['subcats'])) {
        foreach ($categories['subcats'] as $_key => $_val) {
            $categories['subcats'][$_key]['count'] = sqlFetchAll(
                'SELECT count(*) FROM '.$mysql_table_prefix
                .'site_category WHERE category_id='.(int)$_val['category_id']
            );
        }
    }
        
    /* make tree */
    $_parent = $catid;
    while ($_parent) {
        $categories['cat_tree'][] = $categories['categories'][$_parent];
        $_parent = $categories['categories'][$_parent]['parent_num'];
    }
    $categories['cat_tree'] = array_reverse($categories['cat_tree']);

    /* list category sites */
    $categories['cat_sites'] = sqlFetchAll(
        'SELECT url, title, short_desc FROM '.$mysql_table_prefix.'sites, '
        .$mysql_table_prefix.'site_category WHERE category_id='.$catid.' AND '
        .$mysql_table_prefix.'sites.site_id='.$mysql_table_prefix
        .'site_category.site_id order by title'
    );
    
    return $categories;
}
